template<>
struct __attribute__((packed)) guest_layout<drmBufDescFlags> {
  using type = uint32_t;
  type data;
};
template<>
struct __attribute__((packed)) guest_layout<drm_drawable_info_type_t> {
  using type = uint32_t;
  type data;
};
template<>
struct guest_layout<drmHashEntry>;
template<>
struct host_layout<drmHashEntry>;
guest_layout<drmHashEntry>& to_guest(const host_layout<drmHashEntry>&) = delete;
template<>
struct __attribute__((packed)) guest_layout<drmMapFlags> {
  using type = uint32_t;
  type data;
};
template<>
struct __attribute__((packed)) guest_layout<_drmVersion> {
  using type = _drmVersion;
  type data;
};
template<>
struct guest_layout<const _drmVersion> : guest_layout<_drmVersion> {
  guest_layout& operator=(const guest_layout<_drmVersion>& other) { memcpy(this, &other, sizeof(other)); return *this; }
};
template<>
struct host_layout<_drmVersion> {
  using type = _drmVersion;
  type data;

  host_layout(const guest_layout<_drmVersion>& from) :
    data { from.data } {
  }
};

inline guest_layout<_drmVersion> to_guest(const host_layout<_drmVersion>& from) {
  guest_layout<_drmVersion> ret;
  static_assert(sizeof(from) == sizeof(ret));
  memcpy(&ret, &from, sizeof(from));
  return ret;
}

void fex_apply_custom_repacking_entry(host_layout<_drmVersion>& source, const guest_layout<_drmVersion>& from) {
}
bool fex_apply_custom_repacking_exit(guest_layout<_drmVersion>& into, const host_layout<_drmVersion>& from) {
  return false;
}
template<> inline constexpr bool has_compatible_data_layout<_drmVersion> = true;
template<>
struct __attribute__((packed)) guest_layout<drm_context_tFlags> {
  using type = uint32_t;
  type data;
};
template<>
struct __attribute__((packed)) guest_layout<_drmBuf> {
  using type = _drmBuf;
  type data;
};
template<>
struct guest_layout<const _drmBuf> : guest_layout<_drmBuf> {
  guest_layout& operator=(const guest_layout<_drmBuf>& other) { memcpy(this, &other, sizeof(other)); return *this; }
};
template<>
struct host_layout<_drmBuf> {
  using type = _drmBuf;
  type data;

  host_layout(const guest_layout<_drmBuf>& from) :
    data { from.data } {
  }
};

inline guest_layout<_drmBuf> to_guest(const host_layout<_drmBuf>& from) {
  guest_layout<_drmBuf> ret;
  static_assert(sizeof(from) == sizeof(ret));
  memcpy(&ret, &from, sizeof(from));
  return ret;
}

void fex_apply_custom_repacking_entry(host_layout<_drmBuf>& source, const guest_layout<_drmBuf>& from) {
}
bool fex_apply_custom_repacking_exit(guest_layout<_drmBuf>& into, const host_layout<_drmBuf>& from) {
  return false;
}
template<> inline constexpr bool has_compatible_data_layout<_drmBuf> = true;
template<>
struct __attribute__((packed)) guest_layout<_drmServerInfo> {
  using type = _drmServerInfo;
  type data;
};
template<>
struct guest_layout<const _drmServerInfo> : guest_layout<_drmServerInfo> {
  guest_layout& operator=(const guest_layout<_drmServerInfo>& other) { memcpy(this, &other, sizeof(other)); return *this; }
};
template<>
struct host_layout<_drmServerInfo> {
  using type = _drmServerInfo;
  type data;

  host_layout(const guest_layout<_drmServerInfo>& from) :
    data { from.data } {
  }
};

inline guest_layout<_drmServerInfo> to_guest(const host_layout<_drmServerInfo>& from) {
  guest_layout<_drmServerInfo> ret;
  static_assert(sizeof(from) == sizeof(ret));
  memcpy(&ret, &from, sizeof(from));
  return ret;
}

void fex_apply_custom_repacking_entry(host_layout<_drmServerInfo>& source, const guest_layout<_drmServerInfo>& from) {
}
bool fex_apply_custom_repacking_exit(guest_layout<_drmServerInfo>& into, const host_layout<_drmServerInfo>& from) {
  return false;
}
template<> inline constexpr bool has_compatible_data_layout<_drmServerInfo> = true;
template<>
struct __attribute__((packed)) guest_layout<drmDMAFlags> {
  using type = uint32_t;
  type data;
};
template<>
struct __attribute__((packed)) guest_layout<_drmBufDesc> {
  using type = _drmBufDesc;
  type data;
};
template<>
struct guest_layout<const _drmBufDesc> : guest_layout<_drmBufDesc> {
  guest_layout& operator=(const guest_layout<_drmBufDesc>& other) { memcpy(this, &other, sizeof(other)); return *this; }
};
template<>
struct host_layout<_drmBufDesc> {
  using type = _drmBufDesc;
  type data;

  host_layout(const guest_layout<_drmBufDesc>& from) :
    data { from.data } {
  }
};

inline guest_layout<_drmBufDesc> to_guest(const host_layout<_drmBufDesc>& from) {
  guest_layout<_drmBufDesc> ret;
  static_assert(sizeof(from) == sizeof(ret));
  memcpy(&ret, &from, sizeof(from));
  return ret;
}

void fex_apply_custom_repacking_entry(host_layout<_drmBufDesc>& source, const guest_layout<_drmBufDesc>& from) {
}
bool fex_apply_custom_repacking_exit(guest_layout<_drmBufDesc>& into, const host_layout<_drmBufDesc>& from) {
  return false;
}
template<> inline constexpr bool has_compatible_data_layout<_drmBufDesc> = true;
template<>
struct __attribute__((packed)) guest_layout<_drmEventContext> {
  using type = _drmEventContext;
  type data;
};
template<>
struct guest_layout<const _drmEventContext> : guest_layout<_drmEventContext> {
  guest_layout& operator=(const guest_layout<_drmEventContext>& other) { memcpy(this, &other, sizeof(other)); return *this; }
};
template<>
struct host_layout<_drmEventContext> {
  using type = _drmEventContext;
  type data;

  host_layout(const guest_layout<_drmEventContext>& from) :
    data { from.data } {
  }
};

inline guest_layout<_drmEventContext> to_guest(const host_layout<_drmEventContext>& from) {
  guest_layout<_drmEventContext> ret;
  static_assert(sizeof(from) == sizeof(ret));
  memcpy(&ret, &from, sizeof(from));
  return ret;
}

void fex_apply_custom_repacking_entry(host_layout<_drmEventContext>& source, const guest_layout<_drmEventContext>& from) {
}
bool fex_apply_custom_repacking_exit(guest_layout<_drmEventContext>& into, const host_layout<_drmEventContext>& from) {
  return false;
}
template<> inline constexpr bool has_compatible_data_layout<_drmEventContext> = true;
template<>
struct __attribute__((packed)) guest_layout<_drmDevice> {
  using type = _drmDevice;
  type data;
};
template<>
struct guest_layout<const _drmDevice> : guest_layout<_drmDevice> {
  guest_layout& operator=(const guest_layout<_drmDevice>& other) { memcpy(this, &other, sizeof(other)); return *this; }
};
template<>
struct host_layout<_drmDevice> {
  using type = _drmDevice;
  type data;

  host_layout(const guest_layout<_drmDevice>& from) :
    data { from.data } {
  }
};

inline guest_layout<_drmDevice> to_guest(const host_layout<_drmDevice>& from) {
  guest_layout<_drmDevice> ret;
  static_assert(sizeof(from) == sizeof(ret));
  memcpy(&ret, &from, sizeof(from));
  return ret;
}

void fex_apply_custom_repacking_entry(host_layout<_drmDevice>& source, const guest_layout<_drmDevice>& from) {
}
bool fex_apply_custom_repacking_exit(guest_layout<_drmDevice>& into, const host_layout<_drmDevice>& from) {
  return false;
}
template<> inline constexpr bool has_compatible_data_layout<_drmDevice> = true;
template<>
struct __attribute__((packed)) guest_layout<drmMapType> {
  using type = uint32_t;
  type data;
};
template<>
struct __attribute__((packed)) guest_layout<_drmSetVersion> {
  using type = _drmSetVersion;
  type data;
};
template<>
struct guest_layout<const _drmSetVersion> : guest_layout<_drmSetVersion> {
  guest_layout& operator=(const guest_layout<_drmSetVersion>& other) { memcpy(this, &other, sizeof(other)); return *this; }
};
template<>
struct host_layout<_drmSetVersion> {
  using type = _drmSetVersion;
  type data;

  host_layout(const guest_layout<_drmSetVersion>& from) :
    data { from.data } {
  }
};

inline guest_layout<_drmSetVersion> to_guest(const host_layout<_drmSetVersion>& from) {
  guest_layout<_drmSetVersion> ret;
  static_assert(sizeof(from) == sizeof(ret));
  memcpy(&ret, &from, sizeof(from));
  return ret;
}

void fex_apply_custom_repacking_entry(host_layout<_drmSetVersion>& source, const guest_layout<_drmSetVersion>& from) {
}
bool fex_apply_custom_repacking_exit(guest_layout<_drmSetVersion>& into, const host_layout<_drmSetVersion>& from) {
  return false;
}
template<> inline constexpr bool has_compatible_data_layout<_drmSetVersion> = true;
template<>
struct __attribute__((packed)) guest_layout<_drmBufMap> {
  using type = _drmBufMap;
  type data;
};
template<>
struct guest_layout<const _drmBufMap> : guest_layout<_drmBufMap> {
  guest_layout& operator=(const guest_layout<_drmBufMap>& other) { memcpy(this, &other, sizeof(other)); return *this; }
};
template<>
struct host_layout<_drmBufMap> {
  using type = _drmBufMap;
  type data;

  host_layout(const guest_layout<_drmBufMap>& from) :
    data { from.data } {
  }
};

inline guest_layout<_drmBufMap> to_guest(const host_layout<_drmBufMap>& from) {
  guest_layout<_drmBufMap> ret;
  static_assert(sizeof(from) == sizeof(ret));
  memcpy(&ret, &from, sizeof(from));
  return ret;
}

void fex_apply_custom_repacking_entry(host_layout<_drmBufMap>& source, const guest_layout<_drmBufMap>& from) {
}
bool fex_apply_custom_repacking_exit(guest_layout<_drmBufMap>& into, const host_layout<_drmBufMap>& from) {
  return false;
}
template<> inline constexpr bool has_compatible_data_layout<_drmBufMap> = true;
template<>
struct __attribute__((packed)) guest_layout<_drmStats> {
  using type = _drmStats;
  type data;
};
template<>
struct guest_layout<const _drmStats> : guest_layout<_drmStats> {
  guest_layout& operator=(const guest_layout<_drmStats>& other) { memcpy(this, &other, sizeof(other)); return *this; }
};
template<>
struct host_layout<_drmStats> {
  using type = _drmStats;
  type data;

  host_layout(const guest_layout<_drmStats>& from) :
    data { from.data } {
  }
};

inline guest_layout<_drmStats> to_guest(const host_layout<_drmStats>& from) {
  guest_layout<_drmStats> ret;
  static_assert(sizeof(from) == sizeof(ret));
  memcpy(&ret, &from, sizeof(from));
  return ret;
}

void fex_apply_custom_repacking_entry(host_layout<_drmStats>& source, const guest_layout<_drmStats>& from) {
}
bool fex_apply_custom_repacking_exit(guest_layout<_drmStats>& into, const host_layout<_drmStats>& from) {
  return false;
}
template<> inline constexpr bool has_compatible_data_layout<_drmStats> = true;
template<>
struct __attribute__((packed)) guest_layout<_drmDMAReq> {
  using type = _drmDMAReq;
  type data;
};
template<>
struct guest_layout<const _drmDMAReq> : guest_layout<_drmDMAReq> {
  guest_layout& operator=(const guest_layout<_drmDMAReq>& other) { memcpy(this, &other, sizeof(other)); return *this; }
};
template<>
struct host_layout<_drmDMAReq> {
  using type = _drmDMAReq;
  type data;

  host_layout(const guest_layout<_drmDMAReq>& from) :
    data { from.data } {
  }
};

inline guest_layout<_drmDMAReq> to_guest(const host_layout<_drmDMAReq>& from) {
  guest_layout<_drmDMAReq> ret;
  static_assert(sizeof(from) == sizeof(ret));
  memcpy(&ret, &from, sizeof(from));
  return ret;
}

void fex_apply_custom_repacking_entry(host_layout<_drmDMAReq>& source, const guest_layout<_drmDMAReq>& from) {
}
bool fex_apply_custom_repacking_exit(guest_layout<_drmDMAReq>& into, const host_layout<_drmDMAReq>& from) {
  return false;
}
template<> inline constexpr bool has_compatible_data_layout<_drmDMAReq> = true;
template<>
struct __attribute__((packed)) guest_layout<_drmBufInfo> {
  using type = _drmBufInfo;
  type data;
};
template<>
struct guest_layout<const _drmBufInfo> : guest_layout<_drmBufInfo> {
  guest_layout& operator=(const guest_layout<_drmBufInfo>& other) { memcpy(this, &other, sizeof(other)); return *this; }
};
template<>
struct host_layout<_drmBufInfo> {
  using type = _drmBufInfo;
  type data;

  host_layout(const guest_layout<_drmBufInfo>& from) :
    data { from.data } {
  }
};

inline guest_layout<_drmBufInfo> to_guest(const host_layout<_drmBufInfo>& from) {
  guest_layout<_drmBufInfo> ret;
  static_assert(sizeof(from) == sizeof(ret));
  memcpy(&ret, &from, sizeof(from));
  return ret;
}

void fex_apply_custom_repacking_entry(host_layout<_drmBufInfo>& source, const guest_layout<_drmBufInfo>& from) {
}
bool fex_apply_custom_repacking_exit(guest_layout<_drmBufInfo>& into, const host_layout<_drmBufInfo>& from) {
  return false;
}
template<> inline constexpr bool has_compatible_data_layout<_drmBufInfo> = true;
template<>
struct __attribute__((packed)) guest_layout<drmLockFlags> {
  using type = uint32_t;
  type data;
};
using fexldr_type_libdrm_FEX_usable_size = auto (void * a_0) -> size_t;
static fexldr_type_libdrm_FEX_usable_size *fexldr_ptr_libdrm_FEX_usable_size;
using fexldr_type_libdrm_FEX_free_on_host = auto (void * a_0) -> void;
static fexldr_type_libdrm_FEX_free_on_host *fexldr_ptr_libdrm_FEX_free_on_host;
using fexldr_type_libdrm_drmIoctl = auto (int a_0, unsigned long a_1, void * a_2) -> int;
static fexldr_type_libdrm_drmIoctl *fexldr_ptr_libdrm_drmIoctl;
using fexldr_type_libdrm_drmGetHashTable = auto () -> void *;
static fexldr_type_libdrm_drmGetHashTable *fexldr_ptr_libdrm_drmGetHashTable;
using fexldr_type_libdrm_drmGetEntry = auto (int a_0) -> drmHashEntry *;
static fexldr_type_libdrm_drmGetEntry *fexldr_ptr_libdrm_drmGetEntry;
using fexldr_type_libdrm_drmAvailable = auto () -> int;
static fexldr_type_libdrm_drmAvailable *fexldr_ptr_libdrm_drmAvailable;
using fexldr_type_libdrm_drmOpen = auto (const char * a_0, const char * a_1) -> int;
static fexldr_type_libdrm_drmOpen *fexldr_ptr_libdrm_drmOpen;
using fexldr_type_libdrm_drmOpenWithType = auto (const char * a_0, const char * a_1, int a_2) -> int;
static fexldr_type_libdrm_drmOpenWithType *fexldr_ptr_libdrm_drmOpenWithType;
using fexldr_type_libdrm_drmOpenControl = auto (int a_0) -> int;
static fexldr_type_libdrm_drmOpenControl *fexldr_ptr_libdrm_drmOpenControl;
using fexldr_type_libdrm_drmOpenRender = auto (int a_0) -> int;
static fexldr_type_libdrm_drmOpenRender *fexldr_ptr_libdrm_drmOpenRender;
using fexldr_type_libdrm_drmClose = auto (int a_0) -> int;
static fexldr_type_libdrm_drmClose *fexldr_ptr_libdrm_drmClose;
using fexldr_type_libdrm_drmGetVersion = auto (int a_0) -> drmVersionPtr;
static fexldr_type_libdrm_drmGetVersion *fexldr_ptr_libdrm_drmGetVersion;
using fexldr_type_libdrm_drmGetLibVersion = auto (int a_0) -> drmVersionPtr;
static fexldr_type_libdrm_drmGetLibVersion *fexldr_ptr_libdrm_drmGetLibVersion;
using fexldr_type_libdrm_drmGetCap = auto (int a_0, uint64_t a_1, uint64_t * a_2) -> int;
static fexldr_type_libdrm_drmGetCap *fexldr_ptr_libdrm_drmGetCap;
using fexldr_type_libdrm_drmFreeVersion = auto (drmVersionPtr a_0) -> void;
static fexldr_type_libdrm_drmFreeVersion *fexldr_ptr_libdrm_drmFreeVersion;
using fexldr_type_libdrm_drmGetMagic = auto (int a_0, drm_magic_t * a_1) -> int;
static fexldr_type_libdrm_drmGetMagic *fexldr_ptr_libdrm_drmGetMagic;
using fexldr_type_libdrm_drmGetBusid = auto (int a_0) -> char *;
static fexldr_type_libdrm_drmGetBusid *fexldr_ptr_libdrm_drmGetBusid;
using fexldr_type_libdrm_drmGetInterruptFromBusID = auto (int a_0, int a_1, int a_2, int a_3) -> int;
static fexldr_type_libdrm_drmGetInterruptFromBusID *fexldr_ptr_libdrm_drmGetInterruptFromBusID;
using fexldr_type_libdrm_drmGetMap = auto (int a_0, int a_1, drm_handle_t * a_2, drmSize * a_3, drmMapType * a_4, drmMapFlags * a_5, drm_handle_t * a_6, int * a_7) -> int;
static fexldr_type_libdrm_drmGetMap *fexldr_ptr_libdrm_drmGetMap;
using fexldr_type_libdrm_drmGetClient = auto (int a_0, int a_1, int * a_2, int * a_3, int * a_4, unsigned long * a_5, unsigned long * a_6) -> int;
static fexldr_type_libdrm_drmGetClient *fexldr_ptr_libdrm_drmGetClient;
using fexldr_type_libdrm_drmGetStats = auto (int a_0, drmStatsT * a_1) -> int;
static fexldr_type_libdrm_drmGetStats *fexldr_ptr_libdrm_drmGetStats;
using fexldr_type_libdrm_drmSetInterfaceVersion = auto (int a_0, drmSetVersion * a_1) -> int;
static fexldr_type_libdrm_drmSetInterfaceVersion *fexldr_ptr_libdrm_drmSetInterfaceVersion;
using fexldr_type_libdrm_drmCommandNone = auto (int a_0, unsigned long a_1) -> int;
static fexldr_type_libdrm_drmCommandNone *fexldr_ptr_libdrm_drmCommandNone;
using fexldr_type_libdrm_drmCommandRead = auto (int a_0, unsigned long a_1, void * a_2, unsigned long a_3) -> int;
static fexldr_type_libdrm_drmCommandRead *fexldr_ptr_libdrm_drmCommandRead;
using fexldr_type_libdrm_drmCommandWrite = auto (int a_0, unsigned long a_1, void * a_2, unsigned long a_3) -> int;
static fexldr_type_libdrm_drmCommandWrite *fexldr_ptr_libdrm_drmCommandWrite;
using fexldr_type_libdrm_drmCommandWriteRead = auto (int a_0, unsigned long a_1, void * a_2, unsigned long a_3) -> int;
static fexldr_type_libdrm_drmCommandWriteRead *fexldr_ptr_libdrm_drmCommandWriteRead;
using fexldr_type_libdrm_drmFreeBusid = auto (const char * a_0) -> void;
static fexldr_type_libdrm_drmFreeBusid *fexldr_ptr_libdrm_drmFreeBusid;
using fexldr_type_libdrm_drmSetBusid = auto (int a_0, const char * a_1) -> int;
static fexldr_type_libdrm_drmSetBusid *fexldr_ptr_libdrm_drmSetBusid;
using fexldr_type_libdrm_drmAuthMagic = auto (int a_0, drm_magic_t a_1) -> int;
static fexldr_type_libdrm_drmAuthMagic *fexldr_ptr_libdrm_drmAuthMagic;
using fexldr_type_libdrm_drmAddMap = auto (int a_0, drm_handle_t a_1, drmSize a_2, drmMapType a_3, drmMapFlags a_4, drm_handle_t * a_5) -> int;
static fexldr_type_libdrm_drmAddMap *fexldr_ptr_libdrm_drmAddMap;
using fexldr_type_libdrm_drmRmMap = auto (int a_0, drm_handle_t a_1) -> int;
static fexldr_type_libdrm_drmRmMap *fexldr_ptr_libdrm_drmRmMap;
using fexldr_type_libdrm_drmAddContextPrivateMapping = auto (int a_0, drm_context_t a_1, drm_handle_t a_2) -> int;
static fexldr_type_libdrm_drmAddContextPrivateMapping *fexldr_ptr_libdrm_drmAddContextPrivateMapping;
using fexldr_type_libdrm_drmAddBufs = auto (int a_0, int a_1, int a_2, drmBufDescFlags a_3, int a_4) -> int;
static fexldr_type_libdrm_drmAddBufs *fexldr_ptr_libdrm_drmAddBufs;
using fexldr_type_libdrm_drmMarkBufs = auto (int a_0, double a_1, double a_2) -> int;
static fexldr_type_libdrm_drmMarkBufs *fexldr_ptr_libdrm_drmMarkBufs;
using fexldr_type_libdrm_drmCreateContext = auto (int a_0, drm_context_t * a_1) -> int;
static fexldr_type_libdrm_drmCreateContext *fexldr_ptr_libdrm_drmCreateContext;
using fexldr_type_libdrm_drmSetContextFlags = auto (int a_0, drm_context_t a_1, drm_context_tFlags a_2) -> int;
static fexldr_type_libdrm_drmSetContextFlags *fexldr_ptr_libdrm_drmSetContextFlags;
using fexldr_type_libdrm_drmGetContextFlags = auto (int a_0, drm_context_t a_1, drm_context_tFlagsPtr a_2) -> int;
static fexldr_type_libdrm_drmGetContextFlags *fexldr_ptr_libdrm_drmGetContextFlags;
using fexldr_type_libdrm_drmAddContextTag = auto (int a_0, drm_context_t a_1, void * a_2) -> int;
static fexldr_type_libdrm_drmAddContextTag *fexldr_ptr_libdrm_drmAddContextTag;
using fexldr_type_libdrm_drmDelContextTag = auto (int a_0, drm_context_t a_1) -> int;
static fexldr_type_libdrm_drmDelContextTag *fexldr_ptr_libdrm_drmDelContextTag;
using fexldr_type_libdrm_drmGetContextTag = auto (int a_0, drm_context_t a_1) -> void *;
static fexldr_type_libdrm_drmGetContextTag *fexldr_ptr_libdrm_drmGetContextTag;
using fexldr_type_libdrm_drmGetReservedContextList = auto (int a_0, int * a_1) -> drm_context_t *;
static fexldr_type_libdrm_drmGetReservedContextList *fexldr_ptr_libdrm_drmGetReservedContextList;
using fexldr_type_libdrm_drmFreeReservedContextList = auto (drm_context_t * a_0) -> void;
static fexldr_type_libdrm_drmFreeReservedContextList *fexldr_ptr_libdrm_drmFreeReservedContextList;
using fexldr_type_libdrm_drmSwitchToContext = auto (int a_0, drm_context_t a_1) -> int;
static fexldr_type_libdrm_drmSwitchToContext *fexldr_ptr_libdrm_drmSwitchToContext;
using fexldr_type_libdrm_drmDestroyContext = auto (int a_0, drm_context_t a_1) -> int;
static fexldr_type_libdrm_drmDestroyContext *fexldr_ptr_libdrm_drmDestroyContext;
using fexldr_type_libdrm_drmCreateDrawable = auto (int a_0, drm_drawable_t * a_1) -> int;
static fexldr_type_libdrm_drmCreateDrawable *fexldr_ptr_libdrm_drmCreateDrawable;
using fexldr_type_libdrm_drmDestroyDrawable = auto (int a_0, drm_drawable_t a_1) -> int;
static fexldr_type_libdrm_drmDestroyDrawable *fexldr_ptr_libdrm_drmDestroyDrawable;
using fexldr_type_libdrm_drmUpdateDrawableInfo = auto (int a_0, drm_drawable_t a_1, drm_drawable_info_type_t a_2, unsigned int a_3, void * a_4) -> int;
static fexldr_type_libdrm_drmUpdateDrawableInfo *fexldr_ptr_libdrm_drmUpdateDrawableInfo;
using fexldr_type_libdrm_drmCtlInstHandler = auto (int a_0, int a_1) -> int;
static fexldr_type_libdrm_drmCtlInstHandler *fexldr_ptr_libdrm_drmCtlInstHandler;
using fexldr_type_libdrm_drmCtlUninstHandler = auto (int a_0) -> int;
static fexldr_type_libdrm_drmCtlUninstHandler *fexldr_ptr_libdrm_drmCtlUninstHandler;
using fexldr_type_libdrm_drmSetClientCap = auto (int a_0, uint64_t a_1, uint64_t a_2) -> int;
static fexldr_type_libdrm_drmSetClientCap *fexldr_ptr_libdrm_drmSetClientCap;
using fexldr_type_libdrm_drmCrtcGetSequence = auto (int a_0, uint32_t a_1, uint64_t * a_2, uint64_t * a_3) -> int;
static fexldr_type_libdrm_drmCrtcGetSequence *fexldr_ptr_libdrm_drmCrtcGetSequence;
using fexldr_type_libdrm_drmCrtcQueueSequence = auto (int a_0, uint32_t a_1, uint32_t a_2, uint64_t a_3, uint64_t * a_4, uint64_t a_5) -> int;
static fexldr_type_libdrm_drmCrtcQueueSequence *fexldr_ptr_libdrm_drmCrtcQueueSequence;
using fexldr_type_libdrm_drmMap = auto (int a_0, drm_handle_t a_1, drmSize a_2, drmAddressPtr a_3) -> int;
static fexldr_type_libdrm_drmMap *fexldr_ptr_libdrm_drmMap;
using fexldr_type_libdrm_drmUnmap = auto (drmAddress a_0, drmSize a_1) -> int;
static fexldr_type_libdrm_drmUnmap *fexldr_ptr_libdrm_drmUnmap;
using fexldr_type_libdrm_drmGetBufInfo = auto (int a_0) -> drmBufInfoPtr;
static fexldr_type_libdrm_drmGetBufInfo *fexldr_ptr_libdrm_drmGetBufInfo;
using fexldr_type_libdrm_drmMapBufs = auto (int a_0) -> drmBufMapPtr;
static fexldr_type_libdrm_drmMapBufs *fexldr_ptr_libdrm_drmMapBufs;
using fexldr_type_libdrm_drmUnmapBufs = auto (drmBufMapPtr a_0) -> int;
static fexldr_type_libdrm_drmUnmapBufs *fexldr_ptr_libdrm_drmUnmapBufs;
using fexldr_type_libdrm_drmDMA = auto (int a_0, drmDMAReqPtr a_1) -> int;
static fexldr_type_libdrm_drmDMA *fexldr_ptr_libdrm_drmDMA;
using fexldr_type_libdrm_drmFreeBufs = auto (int a_0, int a_1, int * a_2) -> int;
static fexldr_type_libdrm_drmFreeBufs *fexldr_ptr_libdrm_drmFreeBufs;
using fexldr_type_libdrm_drmGetLock = auto (int a_0, drm_context_t a_1, drmLockFlags a_2) -> int;
static fexldr_type_libdrm_drmGetLock *fexldr_ptr_libdrm_drmGetLock;
using fexldr_type_libdrm_drmUnlock = auto (int a_0, drm_context_t a_1) -> int;
static fexldr_type_libdrm_drmUnlock *fexldr_ptr_libdrm_drmUnlock;
using fexldr_type_libdrm_drmFinish = auto (int a_0, int a_1, drmLockFlags a_2) -> int;
static fexldr_type_libdrm_drmFinish *fexldr_ptr_libdrm_drmFinish;
using fexldr_type_libdrm_drmGetContextPrivateMapping = auto (int a_0, drm_context_t a_1, drm_handle_t * a_2) -> int;
static fexldr_type_libdrm_drmGetContextPrivateMapping *fexldr_ptr_libdrm_drmGetContextPrivateMapping;
using fexldr_type_libdrm_drmScatterGatherAlloc = auto (int a_0, unsigned long a_1, drm_handle_t * a_2) -> int;
static fexldr_type_libdrm_drmScatterGatherAlloc *fexldr_ptr_libdrm_drmScatterGatherAlloc;
using fexldr_type_libdrm_drmScatterGatherFree = auto (int a_0, drm_handle_t a_1) -> int;
static fexldr_type_libdrm_drmScatterGatherFree *fexldr_ptr_libdrm_drmScatterGatherFree;
using fexldr_type_libdrm_drmWaitVBlank = auto (int a_0, drmVBlankPtr a_1) -> int;
static fexldr_type_libdrm_drmWaitVBlank *fexldr_ptr_libdrm_drmWaitVBlank;
using fexldr_type_libdrm_drmSetServerInfo = auto (drmServerInfoPtr a_0) -> void;
static fexldr_type_libdrm_drmSetServerInfo *fexldr_ptr_libdrm_drmSetServerInfo;
using fexldr_type_libdrm_drmError = auto (int a_0, const char * a_1) -> int;
static fexldr_type_libdrm_drmError *fexldr_ptr_libdrm_drmError;
using fexldr_type_libdrm_drmMalloc = auto (int a_0) -> void *;
static fexldr_type_libdrm_drmMalloc *fexldr_ptr_libdrm_drmMalloc;
using fexldr_type_libdrm_drmFree = auto (void * a_0) -> void;
static fexldr_type_libdrm_drmFree *fexldr_ptr_libdrm_drmFree;
using fexldr_type_libdrm_drmHashCreate = auto () -> void *;
static fexldr_type_libdrm_drmHashCreate *fexldr_ptr_libdrm_drmHashCreate;
using fexldr_type_libdrm_drmHashDestroy = auto (void * a_0) -> int;
static fexldr_type_libdrm_drmHashDestroy *fexldr_ptr_libdrm_drmHashDestroy;
using fexldr_type_libdrm_drmHashLookup = auto (void * a_0, unsigned long a_1, void ** a_2) -> int;
static fexldr_type_libdrm_drmHashLookup *fexldr_ptr_libdrm_drmHashLookup;
using fexldr_type_libdrm_drmHashInsert = auto (void * a_0, unsigned long a_1, void * a_2) -> int;
static fexldr_type_libdrm_drmHashInsert *fexldr_ptr_libdrm_drmHashInsert;
using fexldr_type_libdrm_drmHashDelete = auto (void * a_0, unsigned long a_1) -> int;
static fexldr_type_libdrm_drmHashDelete *fexldr_ptr_libdrm_drmHashDelete;
using fexldr_type_libdrm_drmHashFirst = auto (void * a_0, unsigned long * a_1, void ** a_2) -> int;
static fexldr_type_libdrm_drmHashFirst *fexldr_ptr_libdrm_drmHashFirst;
using fexldr_type_libdrm_drmHashNext = auto (void * a_0, unsigned long * a_1, void ** a_2) -> int;
static fexldr_type_libdrm_drmHashNext *fexldr_ptr_libdrm_drmHashNext;
using fexldr_type_libdrm_drmRandomCreate = auto (unsigned long a_0) -> void *;
static fexldr_type_libdrm_drmRandomCreate *fexldr_ptr_libdrm_drmRandomCreate;
using fexldr_type_libdrm_drmRandomDestroy = auto (void * a_0) -> int;
static fexldr_type_libdrm_drmRandomDestroy *fexldr_ptr_libdrm_drmRandomDestroy;
using fexldr_type_libdrm_drmRandom = auto (void * a_0) -> unsigned long;
static fexldr_type_libdrm_drmRandom *fexldr_ptr_libdrm_drmRandom;
using fexldr_type_libdrm_drmRandomDouble = auto (void * a_0) -> double;
static fexldr_type_libdrm_drmRandomDouble *fexldr_ptr_libdrm_drmRandomDouble;
using fexldr_type_libdrm_drmSLCreate = auto () -> void *;
static fexldr_type_libdrm_drmSLCreate *fexldr_ptr_libdrm_drmSLCreate;
using fexldr_type_libdrm_drmSLDestroy = auto (void * a_0) -> int;
static fexldr_type_libdrm_drmSLDestroy *fexldr_ptr_libdrm_drmSLDestroy;
using fexldr_type_libdrm_drmSLLookup = auto (void * a_0, unsigned long a_1, void ** a_2) -> int;
static fexldr_type_libdrm_drmSLLookup *fexldr_ptr_libdrm_drmSLLookup;
using fexldr_type_libdrm_drmSLInsert = auto (void * a_0, unsigned long a_1, void * a_2) -> int;
static fexldr_type_libdrm_drmSLInsert *fexldr_ptr_libdrm_drmSLInsert;
using fexldr_type_libdrm_drmSLDelete = auto (void * a_0, unsigned long a_1) -> int;
static fexldr_type_libdrm_drmSLDelete *fexldr_ptr_libdrm_drmSLDelete;
using fexldr_type_libdrm_drmSLNext = auto (void * a_0, unsigned long * a_1, void ** a_2) -> int;
static fexldr_type_libdrm_drmSLNext *fexldr_ptr_libdrm_drmSLNext;
using fexldr_type_libdrm_drmSLFirst = auto (void * a_0, unsigned long * a_1, void ** a_2) -> int;
static fexldr_type_libdrm_drmSLFirst *fexldr_ptr_libdrm_drmSLFirst;
using fexldr_type_libdrm_drmSLDump = auto (void * a_0) -> void;
static fexldr_type_libdrm_drmSLDump *fexldr_ptr_libdrm_drmSLDump;
using fexldr_type_libdrm_drmSLLookupNeighbors = auto (void * a_0, unsigned long a_1, unsigned long * a_2, void ** a_3, unsigned long * a_4, void ** a_5) -> int;
static fexldr_type_libdrm_drmSLLookupNeighbors *fexldr_ptr_libdrm_drmSLLookupNeighbors;
using fexldr_type_libdrm_drmOpenOnce = auto (void * a_0, const char * a_1, int * a_2) -> int;
static fexldr_type_libdrm_drmOpenOnce *fexldr_ptr_libdrm_drmOpenOnce;
using fexldr_type_libdrm_drmOpenOnceWithType = auto (const char * a_0, int * a_1, int a_2) -> int;
static fexldr_type_libdrm_drmOpenOnceWithType *fexldr_ptr_libdrm_drmOpenOnceWithType;
using fexldr_type_libdrm_drmCloseOnce = auto (int a_0) -> void;
static fexldr_type_libdrm_drmCloseOnce *fexldr_ptr_libdrm_drmCloseOnce;
using fexldr_type_libdrm_drmSetMaster = auto (int a_0) -> int;
static fexldr_type_libdrm_drmSetMaster *fexldr_ptr_libdrm_drmSetMaster;
using fexldr_type_libdrm_drmDropMaster = auto (int a_0) -> int;
static fexldr_type_libdrm_drmDropMaster *fexldr_ptr_libdrm_drmDropMaster;
using fexldr_type_libdrm_drmIsMaster = auto (int a_0) -> int;
static fexldr_type_libdrm_drmIsMaster *fexldr_ptr_libdrm_drmIsMaster;
using fexldr_type_libdrm_drmHandleEvent = auto (int a_0, drmEventContextPtr a_1) -> int;
static fexldr_type_libdrm_drmHandleEvent *fexldr_ptr_libdrm_drmHandleEvent;
using fexldr_type_libdrm_drmGetDeviceNameFromFd = auto (int a_0) -> char *;
static fexldr_type_libdrm_drmGetDeviceNameFromFd *fexldr_ptr_libdrm_drmGetDeviceNameFromFd;
using fexldr_type_libdrm_drmGetDeviceNameFromFd2 = auto (int a_0) -> char *;
static fexldr_type_libdrm_drmGetDeviceNameFromFd2 *fexldr_ptr_libdrm_drmGetDeviceNameFromFd2;
using fexldr_type_libdrm_drmGetNodeTypeFromFd = auto (int a_0) -> int;
static fexldr_type_libdrm_drmGetNodeTypeFromFd *fexldr_ptr_libdrm_drmGetNodeTypeFromFd;
using fexldr_type_libdrm_drmPrimeHandleToFD = auto (int a_0, uint32_t a_1, uint32_t a_2, int * a_3) -> int;
static fexldr_type_libdrm_drmPrimeHandleToFD *fexldr_ptr_libdrm_drmPrimeHandleToFD;
using fexldr_type_libdrm_drmPrimeFDToHandle = auto (int a_0, int a_1, uint32_t * a_2) -> int;
static fexldr_type_libdrm_drmPrimeFDToHandle *fexldr_ptr_libdrm_drmPrimeFDToHandle;
using fexldr_type_libdrm_drmGetPrimaryDeviceNameFromFd = auto (int a_0) -> char *;
static fexldr_type_libdrm_drmGetPrimaryDeviceNameFromFd *fexldr_ptr_libdrm_drmGetPrimaryDeviceNameFromFd;
using fexldr_type_libdrm_drmGetRenderDeviceNameFromFd = auto (int a_0) -> char *;
static fexldr_type_libdrm_drmGetRenderDeviceNameFromFd *fexldr_ptr_libdrm_drmGetRenderDeviceNameFromFd;
using fexldr_type_libdrm_drmGetDevice = auto (int a_0, drmDevicePtr * a_1) -> int;
static fexldr_type_libdrm_drmGetDevice *fexldr_ptr_libdrm_drmGetDevice;
using fexldr_type_libdrm_drmFreeDevice = auto (drmDevicePtr * a_0) -> void;
static fexldr_type_libdrm_drmFreeDevice *fexldr_ptr_libdrm_drmFreeDevice;
using fexldr_type_libdrm_drmGetDevices = auto (drmDevicePtr * a_0, int a_1) -> int;
static fexldr_type_libdrm_drmGetDevices *fexldr_ptr_libdrm_drmGetDevices;
using fexldr_type_libdrm_drmFreeDevices = auto (drmDevicePtr * a_0, int a_1) -> void;
static fexldr_type_libdrm_drmFreeDevices *fexldr_ptr_libdrm_drmFreeDevices;
using fexldr_type_libdrm_drmGetDevice2 = auto (int a_0, uint32_t a_1, drmDevicePtr * a_2) -> int;
static fexldr_type_libdrm_drmGetDevice2 *fexldr_ptr_libdrm_drmGetDevice2;
using fexldr_type_libdrm_drmGetDevices2 = auto (uint32_t a_0, drmDevicePtr * a_1, int a_2) -> int;
static fexldr_type_libdrm_drmGetDevices2 *fexldr_ptr_libdrm_drmGetDevices2;
using fexldr_type_libdrm_drmDevicesEqual = auto (drmDevicePtr a_0, drmDevicePtr a_1) -> int;
static fexldr_type_libdrm_drmDevicesEqual *fexldr_ptr_libdrm_drmDevicesEqual;
using fexldr_type_libdrm_drmSyncobjCreate = auto (int a_0, uint32_t a_1, uint32_t * a_2) -> int;
static fexldr_type_libdrm_drmSyncobjCreate *fexldr_ptr_libdrm_drmSyncobjCreate;
using fexldr_type_libdrm_drmSyncobjDestroy = auto (int a_0, uint32_t a_1) -> int;
static fexldr_type_libdrm_drmSyncobjDestroy *fexldr_ptr_libdrm_drmSyncobjDestroy;
using fexldr_type_libdrm_drmSyncobjHandleToFD = auto (int a_0, uint32_t a_1, int * a_2) -> int;
static fexldr_type_libdrm_drmSyncobjHandleToFD *fexldr_ptr_libdrm_drmSyncobjHandleToFD;
using fexldr_type_libdrm_drmSyncobjFDToHandle = auto (int a_0, int a_1, uint32_t * a_2) -> int;
static fexldr_type_libdrm_drmSyncobjFDToHandle *fexldr_ptr_libdrm_drmSyncobjFDToHandle;
using fexldr_type_libdrm_drmSyncobjImportSyncFile = auto (int a_0, uint32_t a_1, int a_2) -> int;
static fexldr_type_libdrm_drmSyncobjImportSyncFile *fexldr_ptr_libdrm_drmSyncobjImportSyncFile;
using fexldr_type_libdrm_drmSyncobjExportSyncFile = auto (int a_0, uint32_t a_1, int * a_2) -> int;
static fexldr_type_libdrm_drmSyncobjExportSyncFile *fexldr_ptr_libdrm_drmSyncobjExportSyncFile;
using fexldr_type_libdrm_drmSyncobjWait = auto (int a_0, uint32_t * a_1, unsigned int a_2, int64_t a_3, unsigned int a_4, uint32_t * a_5) -> int;
static fexldr_type_libdrm_drmSyncobjWait *fexldr_ptr_libdrm_drmSyncobjWait;
using fexldr_type_libdrm_drmSyncobjReset = auto (int a_0, const uint32_t * a_1, uint32_t a_2) -> int;
static fexldr_type_libdrm_drmSyncobjReset *fexldr_ptr_libdrm_drmSyncobjReset;
using fexldr_type_libdrm_drmSyncobjSignal = auto (int a_0, const uint32_t * a_1, uint32_t a_2) -> int;
static fexldr_type_libdrm_drmSyncobjSignal *fexldr_ptr_libdrm_drmSyncobjSignal;
using fexldr_type_libdrm_drmSyncobjTimelineSignal = auto (int a_0, const uint32_t * a_1, uint64_t * a_2, uint32_t a_3) -> int;
static fexldr_type_libdrm_drmSyncobjTimelineSignal *fexldr_ptr_libdrm_drmSyncobjTimelineSignal;
using fexldr_type_libdrm_drmSyncobjTimelineWait = auto (int a_0, uint32_t * a_1, uint64_t * a_2, unsigned int a_3, int64_t a_4, unsigned int a_5, uint32_t * a_6) -> int;
static fexldr_type_libdrm_drmSyncobjTimelineWait *fexldr_ptr_libdrm_drmSyncobjTimelineWait;
using fexldr_type_libdrm_drmSyncobjQuery = auto (int a_0, uint32_t * a_1, uint64_t * a_2, uint32_t a_3) -> int;
static fexldr_type_libdrm_drmSyncobjQuery *fexldr_ptr_libdrm_drmSyncobjQuery;
using fexldr_type_libdrm_drmSyncobjQuery2 = auto (int a_0, uint32_t * a_1, uint64_t * a_2, uint32_t a_3, uint32_t a_4) -> int;
static fexldr_type_libdrm_drmSyncobjQuery2 *fexldr_ptr_libdrm_drmSyncobjQuery2;
using fexldr_type_libdrm_drmSyncobjTransfer = auto (int a_0, uint32_t a_1, uint64_t a_2, uint32_t a_3, uint64_t a_4, uint32_t a_5) -> int;
static fexldr_type_libdrm_drmSyncobjTransfer *fexldr_ptr_libdrm_drmSyncobjTransfer;
extern "C" {
static auto fexfn_impl_libdrm_FEX_usable_size(void * a_0) -> size_t;
struct __attribute__((packed)) fexfn_packed_args_libdrm_FEX_usable_size {
  guest_layout<void *> a_0;
  guest_layout<uint64_t> rv;
};
static void fexfn_unpack_libdrm_FEX_usable_size(fexfn_packed_args_libdrm_FEX_usable_size* args) {
  host_layout<void *> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<size_t>(fexfn_impl_libdrm_FEX_usable_size(unwrap_host(a_0))));
}
static auto fexfn_impl_libdrm_FEX_free_on_host(void * a_0) -> void;
struct __attribute__((packed)) fexfn_packed_args_libdrm_FEX_free_on_host {
  guest_layout<void *> a_0;
};
static void fexfn_unpack_libdrm_FEX_free_on_host(fexfn_packed_args_libdrm_FEX_free_on_host* args) {
  host_layout<void *> a_0 { args->a_0 };
fexfn_impl_libdrm_FEX_free_on_host(unwrap_host(a_0));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmIoctl {
  guest_layout<int32_t> a_0;
  guest_layout<uint64_t> a_1;
  guest_layout<void *> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmIoctl(fexfn_packed_args_libdrm_drmIoctl* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<unsigned long> a_1 { args->a_1 };
  host_layout<void *> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmIoctl(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetHashTable {
  guest_layout<void *> rv;
};
static void fexfn_unpack_libdrm_drmGetHashTable(fexfn_packed_args_libdrm_drmGetHashTable* args) {
  args->rv = to_guest(to_host_layout<void *>(fexldr_ptr_libdrm_drmGetHashTable()));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetEntry {
  guest_layout<int32_t> a_0;
  guest_layout<drmHashEntry *> rv;
};
static void fexfn_unpack_libdrm_drmGetEntry(fexfn_packed_args_libdrm_drmGetEntry* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<drmHashEntry *>(fexldr_ptr_libdrm_drmGetEntry(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmAvailable {
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmAvailable(fexfn_packed_args_libdrm_drmAvailable* args) {
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmAvailable()));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmOpen {
  guest_layout<const uint8_t*> a_0;
  guest_layout<const uint8_t*> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmOpen(fexfn_packed_args_libdrm_drmOpen* args) {
  host_layout<const char *> a_0 { args->a_0 };
  host_layout<const char *> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmOpen(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmOpenWithType {
  guest_layout<const uint8_t*> a_0;
  guest_layout<const uint8_t*> a_1;
  guest_layout<int32_t> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmOpenWithType(fexfn_packed_args_libdrm_drmOpenWithType* args) {
  host_layout<const char *> a_0 { args->a_0 };
  host_layout<const char *> a_1 { args->a_1 };
  host_layout<int> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmOpenWithType(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmOpenControl {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmOpenControl(fexfn_packed_args_libdrm_drmOpenControl* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmOpenControl(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmOpenRender {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmOpenRender(fexfn_packed_args_libdrm_drmOpenRender* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmOpenRender(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmClose {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmClose(fexfn_packed_args_libdrm_drmClose* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmClose(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetVersion {
  guest_layout<int32_t> a_0;
  guest_layout<drmVersionPtr> rv;
};
static void fexfn_unpack_libdrm_drmGetVersion(fexfn_packed_args_libdrm_drmGetVersion* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<drmVersionPtr>(fexldr_ptr_libdrm_drmGetVersion(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetLibVersion {
  guest_layout<int32_t> a_0;
  guest_layout<drmVersionPtr> rv;
};
static void fexfn_unpack_libdrm_drmGetLibVersion(fexfn_packed_args_libdrm_drmGetLibVersion* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<drmVersionPtr>(fexldr_ptr_libdrm_drmGetLibVersion(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetCap {
  guest_layout<int32_t> a_0;
  guest_layout<uint64_t> a_1;
  guest_layout<uint64_t*> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmGetCap(fexfn_packed_args_libdrm_drmGetCap* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<uint64_t> a_1 { args->a_1 };
  host_layout<unsigned long *> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmGetCap(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmFreeVersion {
  guest_layout<drmVersionPtr> a_0;
};
static void fexfn_unpack_libdrm_drmFreeVersion(fexfn_packed_args_libdrm_drmFreeVersion* args) {
  host_layout<_drmVersion *> a_0 { args->a_0 };
fexldr_ptr_libdrm_drmFreeVersion(unwrap_host(a_0));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetMagic {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t*> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmGetMagic(fexfn_packed_args_libdrm_drmGetMagic* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<unsigned int *> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmGetMagic(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetBusid {
  guest_layout<int32_t> a_0;
  guest_layout<uint8_t*> rv;
};
static void fexfn_unpack_libdrm_drmGetBusid(fexfn_packed_args_libdrm_drmGetBusid* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<char *>(fexldr_ptr_libdrm_drmGetBusid(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetInterruptFromBusID {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> a_1;
  guest_layout<int32_t> a_2;
  guest_layout<int32_t> a_3;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmGetInterruptFromBusID(fexfn_packed_args_libdrm_drmGetInterruptFromBusID* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<int> a_1 { args->a_1 };
  host_layout<int> a_2 { args->a_2 };
  host_layout<int> a_3 { args->a_3 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmGetInterruptFromBusID(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetMap {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> a_1;
  guest_layout<uint32_t*> a_2;
  guest_layout<uint32_t*> a_3;
  guest_layout<drmMapType *> a_4;
  guest_layout<drmMapFlags *> a_5;
  guest_layout<uint32_t*> a_6;
  guest_layout<int32_t*> a_7;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmGetMap(fexfn_packed_args_libdrm_drmGetMap* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<int> a_1 { args->a_1 };
  host_layout<unsigned int *> a_2 { args->a_2 };
  host_layout<unsigned int *> a_3 { args->a_3 };
  host_layout<drmMapType *> a_4 { args->a_4 };
  host_layout<drmMapFlags *> a_5 { args->a_5 };
  host_layout<unsigned int *> a_6 { args->a_6 };
  host_layout<int *> a_7 { args->a_7 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmGetMap(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3), unwrap_host(a_4), unwrap_host(a_5), unwrap_host(a_6), unwrap_host(a_7))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetClient {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> a_1;
  guest_layout<int32_t*> a_2;
  guest_layout<int32_t*> a_3;
  guest_layout<int32_t*> a_4;
  guest_layout<uint64_t*> a_5;
  guest_layout<uint64_t*> a_6;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmGetClient(fexfn_packed_args_libdrm_drmGetClient* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<int> a_1 { args->a_1 };
  host_layout<int *> a_2 { args->a_2 };
  host_layout<int *> a_3 { args->a_3 };
  host_layout<int *> a_4 { args->a_4 };
  host_layout<unsigned long *> a_5 { args->a_5 };
  host_layout<unsigned long *> a_6 { args->a_6 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmGetClient(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3), unwrap_host(a_4), unwrap_host(a_5), unwrap_host(a_6))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetStats {
  guest_layout<int32_t> a_0;
  guest_layout<drmStatsT *> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmGetStats(fexfn_packed_args_libdrm_drmGetStats* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<_drmStats *> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmGetStats(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSetInterfaceVersion {
  guest_layout<int32_t> a_0;
  guest_layout<drmSetVersion *> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSetInterfaceVersion(fexfn_packed_args_libdrm_drmSetInterfaceVersion* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<_drmSetVersion *> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSetInterfaceVersion(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmCommandNone {
  guest_layout<int32_t> a_0;
  guest_layout<uint64_t> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmCommandNone(fexfn_packed_args_libdrm_drmCommandNone* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<unsigned long> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmCommandNone(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmCommandRead {
  guest_layout<int32_t> a_0;
  guest_layout<uint64_t> a_1;
  guest_layout<void *> a_2;
  guest_layout<uint64_t> a_3;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmCommandRead(fexfn_packed_args_libdrm_drmCommandRead* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<unsigned long> a_1 { args->a_1 };
  host_layout<void *> a_2 { args->a_2 };
  host_layout<unsigned long> a_3 { args->a_3 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmCommandRead(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmCommandWrite {
  guest_layout<int32_t> a_0;
  guest_layout<uint64_t> a_1;
  guest_layout<void *> a_2;
  guest_layout<uint64_t> a_3;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmCommandWrite(fexfn_packed_args_libdrm_drmCommandWrite* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<unsigned long> a_1 { args->a_1 };
  host_layout<void *> a_2 { args->a_2 };
  host_layout<unsigned long> a_3 { args->a_3 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmCommandWrite(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmCommandWriteRead {
  guest_layout<int32_t> a_0;
  guest_layout<uint64_t> a_1;
  guest_layout<void *> a_2;
  guest_layout<uint64_t> a_3;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmCommandWriteRead(fexfn_packed_args_libdrm_drmCommandWriteRead* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<unsigned long> a_1 { args->a_1 };
  host_layout<void *> a_2 { args->a_2 };
  host_layout<unsigned long> a_3 { args->a_3 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmCommandWriteRead(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmFreeBusid {
  guest_layout<const uint8_t*> a_0;
};
static void fexfn_unpack_libdrm_drmFreeBusid(fexfn_packed_args_libdrm_drmFreeBusid* args) {
  host_layout<const char *> a_0 { args->a_0 };
fexldr_ptr_libdrm_drmFreeBusid(unwrap_host(a_0));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSetBusid {
  guest_layout<int32_t> a_0;
  guest_layout<const uint8_t*> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSetBusid(fexfn_packed_args_libdrm_drmSetBusid* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<const char *> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSetBusid(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmAuthMagic {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmAuthMagic(fexfn_packed_args_libdrm_drmAuthMagic* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_magic_t> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmAuthMagic(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmAddMap {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<uint32_t> a_2;
  guest_layout<drmMapType> a_3;
  guest_layout<drmMapFlags> a_4;
  guest_layout<uint32_t*> a_5;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmAddMap(fexfn_packed_args_libdrm_drmAddMap* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_handle_t> a_1 { args->a_1 };
  host_layout<drmSize> a_2 { args->a_2 };
  host_layout<drmMapType> a_3 { args->a_3 };
  host_layout<drmMapFlags> a_4 { args->a_4 };
  host_layout<unsigned int *> a_5 { args->a_5 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmAddMap(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3), unwrap_host(a_4), unwrap_host(a_5))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmRmMap {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmRmMap(fexfn_packed_args_libdrm_drmRmMap* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_handle_t> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmRmMap(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmAddContextPrivateMapping {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<uint32_t> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmAddContextPrivateMapping(fexfn_packed_args_libdrm_drmAddContextPrivateMapping* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_context_t> a_1 { args->a_1 };
  host_layout<drm_handle_t> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmAddContextPrivateMapping(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmAddBufs {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> a_1;
  guest_layout<int32_t> a_2;
  guest_layout<drmBufDescFlags> a_3;
  guest_layout<int32_t> a_4;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmAddBufs(fexfn_packed_args_libdrm_drmAddBufs* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<int> a_1 { args->a_1 };
  host_layout<int> a_2 { args->a_2 };
  host_layout<drmBufDescFlags> a_3 { args->a_3 };
  host_layout<int> a_4 { args->a_4 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmAddBufs(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3), unwrap_host(a_4))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmMarkBufs {
  guest_layout<int32_t> a_0;
  guest_layout<double> a_1;
  guest_layout<double> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmMarkBufs(fexfn_packed_args_libdrm_drmMarkBufs* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<double> a_1 { args->a_1 };
  host_layout<double> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmMarkBufs(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmCreateContext {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t*> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmCreateContext(fexfn_packed_args_libdrm_drmCreateContext* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<unsigned int *> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmCreateContext(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSetContextFlags {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<drm_context_tFlags> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSetContextFlags(fexfn_packed_args_libdrm_drmSetContextFlags* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_context_t> a_1 { args->a_1 };
  host_layout<drm_context_tFlags> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSetContextFlags(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetContextFlags {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<drm_context_tFlagsPtr> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmGetContextFlags(fexfn_packed_args_libdrm_drmGetContextFlags* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_context_t> a_1 { args->a_1 };
  host_layout<drm_context_tFlags *> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmGetContextFlags(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmAddContextTag {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<void *> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmAddContextTag(fexfn_packed_args_libdrm_drmAddContextTag* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_context_t> a_1 { args->a_1 };
  host_layout<void *> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmAddContextTag(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmDelContextTag {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmDelContextTag(fexfn_packed_args_libdrm_drmDelContextTag* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_context_t> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmDelContextTag(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetContextTag {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<void *> rv;
};
static void fexfn_unpack_libdrm_drmGetContextTag(fexfn_packed_args_libdrm_drmGetContextTag* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_context_t> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<void *>(fexldr_ptr_libdrm_drmGetContextTag(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetReservedContextList {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t*> a_1;
  guest_layout<uint32_t*> rv;
};
static void fexfn_unpack_libdrm_drmGetReservedContextList(fexfn_packed_args_libdrm_drmGetReservedContextList* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<int *> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<drm_context_t *>(fexldr_ptr_libdrm_drmGetReservedContextList(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmFreeReservedContextList {
  guest_layout<uint32_t*> a_0;
};
static void fexfn_unpack_libdrm_drmFreeReservedContextList(fexfn_packed_args_libdrm_drmFreeReservedContextList* args) {
  host_layout<unsigned int *> a_0 { args->a_0 };
fexldr_ptr_libdrm_drmFreeReservedContextList(unwrap_host(a_0));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSwitchToContext {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSwitchToContext(fexfn_packed_args_libdrm_drmSwitchToContext* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_context_t> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSwitchToContext(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmDestroyContext {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmDestroyContext(fexfn_packed_args_libdrm_drmDestroyContext* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_context_t> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmDestroyContext(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmCreateDrawable {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t*> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmCreateDrawable(fexfn_packed_args_libdrm_drmCreateDrawable* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<unsigned int *> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmCreateDrawable(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmDestroyDrawable {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmDestroyDrawable(fexfn_packed_args_libdrm_drmDestroyDrawable* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_drawable_t> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmDestroyDrawable(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmUpdateDrawableInfo {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<drm_drawable_info_type_t> a_2;
  guest_layout<uint32_t> a_3;
  guest_layout<void *> a_4;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmUpdateDrawableInfo(fexfn_packed_args_libdrm_drmUpdateDrawableInfo* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_drawable_t> a_1 { args->a_1 };
  host_layout<drm_drawable_info_type_t> a_2 { args->a_2 };
  host_layout<unsigned int> a_3 { args->a_3 };
  host_layout<void *> a_4 { args->a_4 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmUpdateDrawableInfo(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3), unwrap_host(a_4))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmCtlInstHandler {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmCtlInstHandler(fexfn_packed_args_libdrm_drmCtlInstHandler* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<int> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmCtlInstHandler(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmCtlUninstHandler {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmCtlUninstHandler(fexfn_packed_args_libdrm_drmCtlUninstHandler* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmCtlUninstHandler(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSetClientCap {
  guest_layout<int32_t> a_0;
  guest_layout<uint64_t> a_1;
  guest_layout<uint64_t> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSetClientCap(fexfn_packed_args_libdrm_drmSetClientCap* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<uint64_t> a_1 { args->a_1 };
  host_layout<uint64_t> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSetClientCap(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmCrtcGetSequence {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<uint64_t*> a_2;
  guest_layout<uint64_t*> a_3;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmCrtcGetSequence(fexfn_packed_args_libdrm_drmCrtcGetSequence* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<uint32_t> a_1 { args->a_1 };
  host_layout<unsigned long *> a_2 { args->a_2 };
  host_layout<unsigned long *> a_3 { args->a_3 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmCrtcGetSequence(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmCrtcQueueSequence {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<uint32_t> a_2;
  guest_layout<uint64_t> a_3;
  guest_layout<uint64_t*> a_4;
  guest_layout<uint64_t> a_5;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmCrtcQueueSequence(fexfn_packed_args_libdrm_drmCrtcQueueSequence* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<uint32_t> a_1 { args->a_1 };
  host_layout<uint32_t> a_2 { args->a_2 };
  host_layout<uint64_t> a_3 { args->a_3 };
  host_layout<unsigned long *> a_4 { args->a_4 };
  host_layout<uint64_t> a_5 { args->a_5 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmCrtcQueueSequence(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3), unwrap_host(a_4), unwrap_host(a_5))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmMap {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<uint32_t> a_2;
  guest_layout<drmAddressPtr> a_3;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmMap(fexfn_packed_args_libdrm_drmMap* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_handle_t> a_1 { args->a_1 };
  host_layout<drmSize> a_2 { args->a_2 };
  host_layout<void **> a_3 { args->a_3 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmMap(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmUnmap {
  guest_layout<drmAddress> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmUnmap(fexfn_packed_args_libdrm_drmUnmap* args) {
  host_layout<void *> a_0 { args->a_0 };
  host_layout<drmSize> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmUnmap(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetBufInfo {
  guest_layout<int32_t> a_0;
  guest_layout<drmBufInfoPtr> rv;
};
static void fexfn_unpack_libdrm_drmGetBufInfo(fexfn_packed_args_libdrm_drmGetBufInfo* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<drmBufInfoPtr>(fexldr_ptr_libdrm_drmGetBufInfo(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmMapBufs {
  guest_layout<int32_t> a_0;
  guest_layout<drmBufMapPtr> rv;
};
static void fexfn_unpack_libdrm_drmMapBufs(fexfn_packed_args_libdrm_drmMapBufs* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<drmBufMapPtr>(fexldr_ptr_libdrm_drmMapBufs(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmUnmapBufs {
  guest_layout<drmBufMapPtr> a_0;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmUnmapBufs(fexfn_packed_args_libdrm_drmUnmapBufs* args) {
  host_layout<_drmBufMap *> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmUnmapBufs(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmDMA {
  guest_layout<int32_t> a_0;
  guest_layout<drmDMAReqPtr> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmDMA(fexfn_packed_args_libdrm_drmDMA* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<_drmDMAReq *> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmDMA(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmFreeBufs {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> a_1;
  guest_layout<int32_t*> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmFreeBufs(fexfn_packed_args_libdrm_drmFreeBufs* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<int> a_1 { args->a_1 };
  host_layout<int *> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmFreeBufs(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetLock {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<drmLockFlags> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmGetLock(fexfn_packed_args_libdrm_drmGetLock* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_context_t> a_1 { args->a_1 };
  host_layout<drmLockFlags> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmGetLock(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmUnlock {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmUnlock(fexfn_packed_args_libdrm_drmUnlock* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_context_t> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmUnlock(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmFinish {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> a_1;
  guest_layout<drmLockFlags> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmFinish(fexfn_packed_args_libdrm_drmFinish* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<int> a_1 { args->a_1 };
  host_layout<drmLockFlags> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmFinish(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetContextPrivateMapping {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<uint32_t*> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmGetContextPrivateMapping(fexfn_packed_args_libdrm_drmGetContextPrivateMapping* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_context_t> a_1 { args->a_1 };
  host_layout<unsigned int *> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmGetContextPrivateMapping(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmScatterGatherAlloc {
  guest_layout<int32_t> a_0;
  guest_layout<uint64_t> a_1;
  guest_layout<uint32_t*> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmScatterGatherAlloc(fexfn_packed_args_libdrm_drmScatterGatherAlloc* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<unsigned long> a_1 { args->a_1 };
  host_layout<unsigned int *> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmScatterGatherAlloc(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmScatterGatherFree {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmScatterGatherFree(fexfn_packed_args_libdrm_drmScatterGatherFree* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<drm_handle_t> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmScatterGatherFree(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmWaitVBlank {
  guest_layout<int32_t> a_0;
  guest_layout<drmVBlankPtr> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmWaitVBlank(fexfn_packed_args_libdrm_drmWaitVBlank* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<_drmVBlank *> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmWaitVBlank(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSetServerInfo {
  guest_layout<drmServerInfoPtr> a_0;
};
static void fexfn_unpack_libdrm_drmSetServerInfo(fexfn_packed_args_libdrm_drmSetServerInfo* args) {
  host_layout<_drmServerInfo *> a_0 { args->a_0 };
fexldr_ptr_libdrm_drmSetServerInfo(unwrap_host(a_0));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmError {
  guest_layout<int32_t> a_0;
  guest_layout<const uint8_t*> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmError(fexfn_packed_args_libdrm_drmError* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<const char *> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmError(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmMalloc {
  guest_layout<int32_t> a_0;
  guest_layout<void *> rv;
};
static void fexfn_unpack_libdrm_drmMalloc(fexfn_packed_args_libdrm_drmMalloc* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<void *>(fexldr_ptr_libdrm_drmMalloc(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmFree {
  guest_layout<void *> a_0;
};
static void fexfn_unpack_libdrm_drmFree(fexfn_packed_args_libdrm_drmFree* args) {
  host_layout<void *> a_0 { args->a_0 };
fexldr_ptr_libdrm_drmFree(unwrap_host(a_0));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmHashCreate {
  guest_layout<void *> rv;
};
static void fexfn_unpack_libdrm_drmHashCreate(fexfn_packed_args_libdrm_drmHashCreate* args) {
  args->rv = to_guest(to_host_layout<void *>(fexldr_ptr_libdrm_drmHashCreate()));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmHashDestroy {
  guest_layout<void *> a_0;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmHashDestroy(fexfn_packed_args_libdrm_drmHashDestroy* args) {
  host_layout<void *> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmHashDestroy(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmHashLookup {
  guest_layout<void *> a_0;
  guest_layout<uint64_t> a_1;
  guest_layout<void **> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmHashLookup(fexfn_packed_args_libdrm_drmHashLookup* args) {
  host_layout<void *> a_0 { args->a_0 };
  host_layout<unsigned long> a_1 { args->a_1 };
  host_layout<void **> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmHashLookup(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmHashInsert {
  guest_layout<void *> a_0;
  guest_layout<uint64_t> a_1;
  guest_layout<void *> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmHashInsert(fexfn_packed_args_libdrm_drmHashInsert* args) {
  host_layout<void *> a_0 { args->a_0 };
  host_layout<unsigned long> a_1 { args->a_1 };
  host_layout<void *> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmHashInsert(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmHashDelete {
  guest_layout<void *> a_0;
  guest_layout<uint64_t> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmHashDelete(fexfn_packed_args_libdrm_drmHashDelete* args) {
  host_layout<void *> a_0 { args->a_0 };
  host_layout<unsigned long> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmHashDelete(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmHashFirst {
  guest_layout<void *> a_0;
  guest_layout<uint64_t*> a_1;
  guest_layout<void **> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmHashFirst(fexfn_packed_args_libdrm_drmHashFirst* args) {
  host_layout<void *> a_0 { args->a_0 };
  host_layout<unsigned long *> a_1 { args->a_1 };
  host_layout<void **> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmHashFirst(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmHashNext {
  guest_layout<void *> a_0;
  guest_layout<uint64_t*> a_1;
  guest_layout<void **> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmHashNext(fexfn_packed_args_libdrm_drmHashNext* args) {
  host_layout<void *> a_0 { args->a_0 };
  host_layout<unsigned long *> a_1 { args->a_1 };
  host_layout<void **> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmHashNext(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmRandomCreate {
  guest_layout<uint64_t> a_0;
  guest_layout<void *> rv;
};
static void fexfn_unpack_libdrm_drmRandomCreate(fexfn_packed_args_libdrm_drmRandomCreate* args) {
  host_layout<unsigned long> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<void *>(fexldr_ptr_libdrm_drmRandomCreate(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmRandomDestroy {
  guest_layout<void *> a_0;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmRandomDestroy(fexfn_packed_args_libdrm_drmRandomDestroy* args) {
  host_layout<void *> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmRandomDestroy(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmRandom {
  guest_layout<void *> a_0;
  guest_layout<uint64_t> rv;
};
static void fexfn_unpack_libdrm_drmRandom(fexfn_packed_args_libdrm_drmRandom* args) {
  host_layout<void *> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<unsigned long>(fexldr_ptr_libdrm_drmRandom(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmRandomDouble {
  guest_layout<void *> a_0;
  guest_layout<double> rv;
};
static void fexfn_unpack_libdrm_drmRandomDouble(fexfn_packed_args_libdrm_drmRandomDouble* args) {
  host_layout<void *> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<double>(fexldr_ptr_libdrm_drmRandomDouble(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSLCreate {
  guest_layout<void *> rv;
};
static void fexfn_unpack_libdrm_drmSLCreate(fexfn_packed_args_libdrm_drmSLCreate* args) {
  args->rv = to_guest(to_host_layout<void *>(fexldr_ptr_libdrm_drmSLCreate()));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSLDestroy {
  guest_layout<void *> a_0;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSLDestroy(fexfn_packed_args_libdrm_drmSLDestroy* args) {
  host_layout<void *> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSLDestroy(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSLLookup {
  guest_layout<void *> a_0;
  guest_layout<uint64_t> a_1;
  guest_layout<void **> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSLLookup(fexfn_packed_args_libdrm_drmSLLookup* args) {
  host_layout<void *> a_0 { args->a_0 };
  host_layout<unsigned long> a_1 { args->a_1 };
  host_layout<void **> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSLLookup(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSLInsert {
  guest_layout<void *> a_0;
  guest_layout<uint64_t> a_1;
  guest_layout<void *> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSLInsert(fexfn_packed_args_libdrm_drmSLInsert* args) {
  host_layout<void *> a_0 { args->a_0 };
  host_layout<unsigned long> a_1 { args->a_1 };
  host_layout<void *> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSLInsert(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSLDelete {
  guest_layout<void *> a_0;
  guest_layout<uint64_t> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSLDelete(fexfn_packed_args_libdrm_drmSLDelete* args) {
  host_layout<void *> a_0 { args->a_0 };
  host_layout<unsigned long> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSLDelete(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSLNext {
  guest_layout<void *> a_0;
  guest_layout<uint64_t*> a_1;
  guest_layout<void **> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSLNext(fexfn_packed_args_libdrm_drmSLNext* args) {
  host_layout<void *> a_0 { args->a_0 };
  host_layout<unsigned long *> a_1 { args->a_1 };
  host_layout<void **> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSLNext(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSLFirst {
  guest_layout<void *> a_0;
  guest_layout<uint64_t*> a_1;
  guest_layout<void **> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSLFirst(fexfn_packed_args_libdrm_drmSLFirst* args) {
  host_layout<void *> a_0 { args->a_0 };
  host_layout<unsigned long *> a_1 { args->a_1 };
  host_layout<void **> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSLFirst(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSLDump {
  guest_layout<void *> a_0;
};
static void fexfn_unpack_libdrm_drmSLDump(fexfn_packed_args_libdrm_drmSLDump* args) {
  host_layout<void *> a_0 { args->a_0 };
fexldr_ptr_libdrm_drmSLDump(unwrap_host(a_0));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSLLookupNeighbors {
  guest_layout<void *> a_0;
  guest_layout<uint64_t> a_1;
  guest_layout<uint64_t*> a_2;
  guest_layout<void **> a_3;
  guest_layout<uint64_t*> a_4;
  guest_layout<void **> a_5;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSLLookupNeighbors(fexfn_packed_args_libdrm_drmSLLookupNeighbors* args) {
  host_layout<void *> a_0 { args->a_0 };
  host_layout<unsigned long> a_1 { args->a_1 };
  host_layout<unsigned long *> a_2 { args->a_2 };
  host_layout<void **> a_3 { args->a_3 };
  host_layout<unsigned long *> a_4 { args->a_4 };
  host_layout<void **> a_5 { args->a_5 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSLLookupNeighbors(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3), unwrap_host(a_4), unwrap_host(a_5))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmOpenOnce {
  guest_layout<void *> a_0;
  guest_layout<const uint8_t*> a_1;
  guest_layout<int32_t*> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmOpenOnce(fexfn_packed_args_libdrm_drmOpenOnce* args) {
  host_layout<void *> a_0 { args->a_0 };
  host_layout<const char *> a_1 { args->a_1 };
  host_layout<int *> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmOpenOnce(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmOpenOnceWithType {
  guest_layout<const uint8_t*> a_0;
  guest_layout<int32_t*> a_1;
  guest_layout<int32_t> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmOpenOnceWithType(fexfn_packed_args_libdrm_drmOpenOnceWithType* args) {
  host_layout<const char *> a_0 { args->a_0 };
  host_layout<int *> a_1 { args->a_1 };
  host_layout<int> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmOpenOnceWithType(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmCloseOnce {
  guest_layout<int32_t> a_0;
};
static void fexfn_unpack_libdrm_drmCloseOnce(fexfn_packed_args_libdrm_drmCloseOnce* args) {
  host_layout<int> a_0 { args->a_0 };
fexldr_ptr_libdrm_drmCloseOnce(unwrap_host(a_0));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSetMaster {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSetMaster(fexfn_packed_args_libdrm_drmSetMaster* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSetMaster(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmDropMaster {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmDropMaster(fexfn_packed_args_libdrm_drmDropMaster* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmDropMaster(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmIsMaster {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmIsMaster(fexfn_packed_args_libdrm_drmIsMaster* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmIsMaster(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmHandleEvent {
  guest_layout<int32_t> a_0;
  guest_layout<drmEventContextPtr> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmHandleEvent(fexfn_packed_args_libdrm_drmHandleEvent* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<_drmEventContext *> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmHandleEvent(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetDeviceNameFromFd {
  guest_layout<int32_t> a_0;
  guest_layout<uint8_t*> rv;
};
static void fexfn_unpack_libdrm_drmGetDeviceNameFromFd(fexfn_packed_args_libdrm_drmGetDeviceNameFromFd* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<char *>(fexldr_ptr_libdrm_drmGetDeviceNameFromFd(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetDeviceNameFromFd2 {
  guest_layout<int32_t> a_0;
  guest_layout<uint8_t*> rv;
};
static void fexfn_unpack_libdrm_drmGetDeviceNameFromFd2(fexfn_packed_args_libdrm_drmGetDeviceNameFromFd2* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<char *>(fexldr_ptr_libdrm_drmGetDeviceNameFromFd2(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetNodeTypeFromFd {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmGetNodeTypeFromFd(fexfn_packed_args_libdrm_drmGetNodeTypeFromFd* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmGetNodeTypeFromFd(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmPrimeHandleToFD {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<uint32_t> a_2;
  guest_layout<int32_t*> a_3;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmPrimeHandleToFD(fexfn_packed_args_libdrm_drmPrimeHandleToFD* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<uint32_t> a_1 { args->a_1 };
  host_layout<uint32_t> a_2 { args->a_2 };
  host_layout<int *> a_3 { args->a_3 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmPrimeHandleToFD(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmPrimeFDToHandle {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> a_1;
  guest_layout<uint32_t*> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmPrimeFDToHandle(fexfn_packed_args_libdrm_drmPrimeFDToHandle* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<int> a_1 { args->a_1 };
  host_layout<unsigned int *> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmPrimeFDToHandle(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetPrimaryDeviceNameFromFd {
  guest_layout<int32_t> a_0;
  guest_layout<uint8_t*> rv;
};
static void fexfn_unpack_libdrm_drmGetPrimaryDeviceNameFromFd(fexfn_packed_args_libdrm_drmGetPrimaryDeviceNameFromFd* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<char *>(fexldr_ptr_libdrm_drmGetPrimaryDeviceNameFromFd(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetRenderDeviceNameFromFd {
  guest_layout<int32_t> a_0;
  guest_layout<uint8_t*> rv;
};
static void fexfn_unpack_libdrm_drmGetRenderDeviceNameFromFd(fexfn_packed_args_libdrm_drmGetRenderDeviceNameFromFd* args) {
  host_layout<int> a_0 { args->a_0 };
  args->rv = to_guest(to_host_layout<char *>(fexldr_ptr_libdrm_drmGetRenderDeviceNameFromFd(unwrap_host(a_0))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetDevice {
  guest_layout<int32_t> a_0;
  guest_layout<drmDevicePtr *> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmGetDevice(fexfn_packed_args_libdrm_drmGetDevice* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<_drmDevice **> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmGetDevice(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmFreeDevice {
  guest_layout<drmDevicePtr *> a_0;
};
static void fexfn_unpack_libdrm_drmFreeDevice(fexfn_packed_args_libdrm_drmFreeDevice* args) {
  host_layout<_drmDevice **> a_0 { args->a_0 };
fexldr_ptr_libdrm_drmFreeDevice(unwrap_host(a_0));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetDevices {
  guest_layout<drmDevicePtr *> a_0;
  guest_layout<int32_t> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmGetDevices(fexfn_packed_args_libdrm_drmGetDevices* args) {
  host_layout<_drmDevice **> a_0 { args->a_0 };
  host_layout<int> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmGetDevices(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmFreeDevices {
  guest_layout<drmDevicePtr *> a_0;
  guest_layout<int32_t> a_1;
};
static void fexfn_unpack_libdrm_drmFreeDevices(fexfn_packed_args_libdrm_drmFreeDevices* args) {
  host_layout<_drmDevice **> a_0 { args->a_0 };
  host_layout<int> a_1 { args->a_1 };
fexldr_ptr_libdrm_drmFreeDevices(unwrap_host(a_0), unwrap_host(a_1));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetDevice2 {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<drmDevicePtr *> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmGetDevice2(fexfn_packed_args_libdrm_drmGetDevice2* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<uint32_t> a_1 { args->a_1 };
  host_layout<_drmDevice **> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmGetDevice2(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmGetDevices2 {
  guest_layout<uint32_t> a_0;
  guest_layout<drmDevicePtr *> a_1;
  guest_layout<int32_t> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmGetDevices2(fexfn_packed_args_libdrm_drmGetDevices2* args) {
  host_layout<uint32_t> a_0 { args->a_0 };
  host_layout<_drmDevice **> a_1 { args->a_1 };
  host_layout<int> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmGetDevices2(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmDevicesEqual {
  guest_layout<drmDevicePtr> a_0;
  guest_layout<drmDevicePtr> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmDevicesEqual(fexfn_packed_args_libdrm_drmDevicesEqual* args) {
  host_layout<_drmDevice *> a_0 { args->a_0 };
  host_layout<_drmDevice *> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmDevicesEqual(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSyncobjCreate {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<uint32_t*> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSyncobjCreate(fexfn_packed_args_libdrm_drmSyncobjCreate* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<uint32_t> a_1 { args->a_1 };
  host_layout<unsigned int *> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSyncobjCreate(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSyncobjDestroy {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSyncobjDestroy(fexfn_packed_args_libdrm_drmSyncobjDestroy* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<uint32_t> a_1 { args->a_1 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSyncobjDestroy(unwrap_host(a_0), unwrap_host(a_1))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSyncobjHandleToFD {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<int32_t*> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSyncobjHandleToFD(fexfn_packed_args_libdrm_drmSyncobjHandleToFD* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<uint32_t> a_1 { args->a_1 };
  host_layout<int *> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSyncobjHandleToFD(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSyncobjFDToHandle {
  guest_layout<int32_t> a_0;
  guest_layout<int32_t> a_1;
  guest_layout<uint32_t*> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSyncobjFDToHandle(fexfn_packed_args_libdrm_drmSyncobjFDToHandle* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<int> a_1 { args->a_1 };
  host_layout<unsigned int *> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSyncobjFDToHandle(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSyncobjImportSyncFile {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<int32_t> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSyncobjImportSyncFile(fexfn_packed_args_libdrm_drmSyncobjImportSyncFile* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<uint32_t> a_1 { args->a_1 };
  host_layout<int> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSyncobjImportSyncFile(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSyncobjExportSyncFile {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<int32_t*> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSyncobjExportSyncFile(fexfn_packed_args_libdrm_drmSyncobjExportSyncFile* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<uint32_t> a_1 { args->a_1 };
  host_layout<int *> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSyncobjExportSyncFile(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSyncobjWait {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t*> a_1;
  guest_layout<uint32_t> a_2;
  guest_layout<int64_t> a_3;
  guest_layout<uint32_t> a_4;
  guest_layout<uint32_t*> a_5;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSyncobjWait(fexfn_packed_args_libdrm_drmSyncobjWait* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<unsigned int *> a_1 { args->a_1 };
  host_layout<unsigned int> a_2 { args->a_2 };
  host_layout<int64_t> a_3 { args->a_3 };
  host_layout<unsigned int> a_4 { args->a_4 };
  host_layout<unsigned int *> a_5 { args->a_5 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSyncobjWait(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3), unwrap_host(a_4), unwrap_host(a_5))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSyncobjReset {
  guest_layout<int32_t> a_0;
  guest_layout<const uint32_t*> a_1;
  guest_layout<uint32_t> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSyncobjReset(fexfn_packed_args_libdrm_drmSyncobjReset* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<const unsigned int *> a_1 { args->a_1 };
  host_layout<uint32_t> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSyncobjReset(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSyncobjSignal {
  guest_layout<int32_t> a_0;
  guest_layout<const uint32_t*> a_1;
  guest_layout<uint32_t> a_2;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSyncobjSignal(fexfn_packed_args_libdrm_drmSyncobjSignal* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<const unsigned int *> a_1 { args->a_1 };
  host_layout<uint32_t> a_2 { args->a_2 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSyncobjSignal(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSyncobjTimelineSignal {
  guest_layout<int32_t> a_0;
  guest_layout<const uint32_t*> a_1;
  guest_layout<uint64_t*> a_2;
  guest_layout<uint32_t> a_3;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSyncobjTimelineSignal(fexfn_packed_args_libdrm_drmSyncobjTimelineSignal* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<const unsigned int *> a_1 { args->a_1 };
  host_layout<unsigned long *> a_2 { args->a_2 };
  host_layout<uint32_t> a_3 { args->a_3 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSyncobjTimelineSignal(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSyncobjTimelineWait {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t*> a_1;
  guest_layout<uint64_t*> a_2;
  guest_layout<uint32_t> a_3;
  guest_layout<int64_t> a_4;
  guest_layout<uint32_t> a_5;
  guest_layout<uint32_t*> a_6;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSyncobjTimelineWait(fexfn_packed_args_libdrm_drmSyncobjTimelineWait* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<unsigned int *> a_1 { args->a_1 };
  host_layout<unsigned long *> a_2 { args->a_2 };
  host_layout<unsigned int> a_3 { args->a_3 };
  host_layout<int64_t> a_4 { args->a_4 };
  host_layout<unsigned int> a_5 { args->a_5 };
  host_layout<unsigned int *> a_6 { args->a_6 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSyncobjTimelineWait(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3), unwrap_host(a_4), unwrap_host(a_5), unwrap_host(a_6))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSyncobjQuery {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t*> a_1;
  guest_layout<uint64_t*> a_2;
  guest_layout<uint32_t> a_3;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSyncobjQuery(fexfn_packed_args_libdrm_drmSyncobjQuery* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<unsigned int *> a_1 { args->a_1 };
  host_layout<unsigned long *> a_2 { args->a_2 };
  host_layout<uint32_t> a_3 { args->a_3 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSyncobjQuery(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSyncobjQuery2 {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t*> a_1;
  guest_layout<uint64_t*> a_2;
  guest_layout<uint32_t> a_3;
  guest_layout<uint32_t> a_4;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSyncobjQuery2(fexfn_packed_args_libdrm_drmSyncobjQuery2* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<unsigned int *> a_1 { args->a_1 };
  host_layout<unsigned long *> a_2 { args->a_2 };
  host_layout<uint32_t> a_3 { args->a_3 };
  host_layout<uint32_t> a_4 { args->a_4 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSyncobjQuery2(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3), unwrap_host(a_4))));
}
struct __attribute__((packed)) fexfn_packed_args_libdrm_drmSyncobjTransfer {
  guest_layout<int32_t> a_0;
  guest_layout<uint32_t> a_1;
  guest_layout<uint64_t> a_2;
  guest_layout<uint32_t> a_3;
  guest_layout<uint64_t> a_4;
  guest_layout<uint32_t> a_5;
  guest_layout<int32_t> rv;
};
static void fexfn_unpack_libdrm_drmSyncobjTransfer(fexfn_packed_args_libdrm_drmSyncobjTransfer* args) {
  host_layout<int> a_0 { args->a_0 };
  host_layout<uint32_t> a_1 { args->a_1 };
  host_layout<uint64_t> a_2 { args->a_2 };
  host_layout<uint32_t> a_3 { args->a_3 };
  host_layout<uint64_t> a_4 { args->a_4 };
  host_layout<uint32_t> a_5 { args->a_5 };
  args->rv = to_guest(to_host_layout<int>(fexldr_ptr_libdrm_drmSyncobjTransfer(unwrap_host(a_0), unwrap_host(a_1), unwrap_host(a_2), unwrap_host(a_3), unwrap_host(a_4), unwrap_host(a_5))));
}
}
static ExportEntry exports[] = {
  {(uint8_t*)"\x4c\xca\x14\x62\x84\xa7\xf7\xe7\x25\x5f\xe6\x3b\xd3\x0e\x57\x52\x73\x16\xb4\x10\xd4\xc9\x2a\xbb\xcf\x38\x03\xd0\x7a\xf4\xa0\xd4", (void(*)(void *))&fexfn_unpack_libdrm_FEX_usable_size}, // libdrm:FEX_usable_size
  {(uint8_t*)"\x54\x61\x52\x6e\x62\x35\x74\x20\x4b\x5d\x0f\x60\x68\x9c\xbc\x13\xe5\x06\xd6\x5f\xac\x25\x75\xb0\x11\xc9\xeb\xa1\x7b\xf0\xa6\x48", (void(*)(void *))&fexfn_unpack_libdrm_FEX_free_on_host}, // libdrm:FEX_free_on_host
  {(uint8_t*)"\x02\x73\x0d\x85\x03\xa8\x16\x9e\x69\xc3\x59\x11\x72\xae\x9c\x7c\x0d\x72\x55\x9f\x68\x05\x2f\x21\xfe\x51\x2d\x51\x72\x16\xe2\x37", (void(*)(void *))&fexfn_unpack_libdrm_drmIoctl}, // libdrm:drmIoctl
  {(uint8_t*)"\x6c\xa7\xe8\x82\xe7\x12\xd4\x81\x4d\x7f\x53\xac\xde\x01\x4c\xf2\x66\x82\xb8\x59\x7b\x20\x24\x50\x64\x45\x99\xd5\xc0\x44\x13\xd0", (void(*)(void *))&fexfn_unpack_libdrm_drmGetHashTable}, // libdrm:drmGetHashTable
  {(uint8_t*)"\x18\x20\x54\x7b\xb3\x22\x3e\x32\xe9\xeb\xec\xde\xb9\xde\xec\x5b\x71\x6e\x0a\xe4\x7a\x5c\x18\x02\x20\xa1\x9e\x74\x9f\xad\x0b\x45", (void(*)(void *))&fexfn_unpack_libdrm_drmGetEntry}, // libdrm:drmGetEntry
  {(uint8_t*)"\x0c\x87\x65\x5b\x39\x8c\x0a\xab\x85\x3b\x24\x2d\xe4\xea\xad\x3c\xa2\xe6\x7d\xed\x9f\x15\x68\x01\xac\x0c\x63\xeb\x85\xa8\xb8\x29", (void(*)(void *))&fexfn_unpack_libdrm_drmAvailable}, // libdrm:drmAvailable
  {(uint8_t*)"\xac\xfc\x57\x2b\x2b\x91\xb7\x82\xc4\xa4\xe9\x53\x35\xe6\x47\xfc\x71\xdc\x39\x6d\x2f\xc2\x99\xf4\x85\xba\x40\x15\xd1\xd0\x49\x99", (void(*)(void *))&fexfn_unpack_libdrm_drmOpen}, // libdrm:drmOpen
  {(uint8_t*)"\x56\x2e\xe5\xfb\x8f\x3b\x2d\x12\x3e\x63\x57\x52\xe8\x6b\x65\x81\x05\xd1\xfb\x7a\xfb\xa9\x1e\xd4\x82\x7f\x2a\xa5\x82\x86\x86\xe1", (void(*)(void *))&fexfn_unpack_libdrm_drmOpenWithType}, // libdrm:drmOpenWithType
  {(uint8_t*)"\xf4\xae\x59\x12\xa0\xa0\x3f\x17\xfd\x88\x8e\xe0\x4b\xf7\xca\x1a\x2b\x7a\x7c\xb6\x34\xf7\x84\x9c\x50\x14\x6d\x95\x7e\x6c\xfd\xc0", (void(*)(void *))&fexfn_unpack_libdrm_drmOpenControl}, // libdrm:drmOpenControl
  {(uint8_t*)"\x28\x54\xdf\x47\x6f\x1c\x06\x13\xda\x73\xb7\x94\x1d\xaa\x06\xf7\x69\x74\xcd\xc5\x5b\xfe\x49\xcb\xeb\x60\x0e\x32\x45\xf3\x14\x47", (void(*)(void *))&fexfn_unpack_libdrm_drmOpenRender}, // libdrm:drmOpenRender
  {(uint8_t*)"\xed\x73\x1a\x6f\xd6\x6e\x32\xcd\xbc\xda\x39\x83\x42\xea\xd7\x58\x34\x7d\x88\xfa\x3d\x13\xaf\xd6\x98\x85\x88\xc1\x43\x9c\x2b\xf3", (void(*)(void *))&fexfn_unpack_libdrm_drmClose}, // libdrm:drmClose
  {(uint8_t*)"\xa1\xbb\x23\xf4\xdb\x70\x25\x4a\x6e\xdc\x50\x8d\x06\xfc\x6e\xf0\x8b\x9e\x10\xa3\x98\x4d\x7f\xfd\x2e\x0d\x25\xef\xf3\x4e\x14\x0e", (void(*)(void *))&fexfn_unpack_libdrm_drmGetVersion}, // libdrm:drmGetVersion
  {(uint8_t*)"\x73\xf2\x2d\xf6\xbe\xa8\x10\xf8\xd9\x96\xea\x84\x7f\x82\x05\xad\x55\x4e\xb5\x75\xcf\xf8\xc7\xed\xeb\x5a\x23\xac\x9d\xf4\x7a\xf3", (void(*)(void *))&fexfn_unpack_libdrm_drmGetLibVersion}, // libdrm:drmGetLibVersion
  {(uint8_t*)"\xa5\xfe\xc2\xd6\x40\xd5\x5e\x4f\xf9\x5d\x40\xd9\x3f\x3f\x8a\x06\xe9\x1e\xe6\xe6\x43\xa6\x93\x28\x4d\xa6\x78\x1c\x72\xcb\xc9\x24", (void(*)(void *))&fexfn_unpack_libdrm_drmGetCap}, // libdrm:drmGetCap
  {(uint8_t*)"\x9f\x0f\x73\xe6\xf8\x61\x4e\x29\xea\x58\xb0\x03\x8a\x26\xfe\x13\x5a\x6c\x08\x85\x83\x99\x39\x65\x2f\x11\x59\xea\xb2\x05\x2c\x45", (void(*)(void *))&fexfn_unpack_libdrm_drmFreeVersion}, // libdrm:drmFreeVersion
  {(uint8_t*)"\x94\x5b\x5a\x3f\xd9\x6d\x59\x79\xf8\x08\xee\xf3\x9b\x0a\xf4\x36\xe9\xc2\xc7\xd9\x43\x60\x37\xcb\xf8\xe6\xda\xb1\x9a\x93\x5b\x1c", (void(*)(void *))&fexfn_unpack_libdrm_drmGetMagic}, // libdrm:drmGetMagic
  {(uint8_t*)"\xaf\x94\x93\x2a\x01\xa5\x27\xc0\x7a\x5e\xd5\xcf\x18\x69\x9c\x42\x57\x17\x1e\x34\x18\xce\xb3\x89\x6f\x05\x62\xc2\xac\xfe\xdf\x0d", (void(*)(void *))&fexfn_unpack_libdrm_drmGetBusid}, // libdrm:drmGetBusid
  {(uint8_t*)"\xc7\x0b\x25\xaa\x91\xdd\x51\xb4\x0b\x66\x68\x3f\xcf\xc5\x5b\xe6\x71\x13\xa2\x98\x15\xdd\x08\x6c\x17\x87\x7b\x18\x4e\x0b\xf5\x74", (void(*)(void *))&fexfn_unpack_libdrm_drmGetInterruptFromBusID}, // libdrm:drmGetInterruptFromBusID
  {(uint8_t*)"\xe0\x25\xa3\x0f\xb3\x07\x88\xf1\xe5\x48\x9e\xe0\xdd\x6f\x7f\x17\x9c\x8f\x52\x7c\x64\x4a\xc2\x3a\xba\xf4\x95\x44\x57\x35\x71\xec", (void(*)(void *))&fexfn_unpack_libdrm_drmGetMap}, // libdrm:drmGetMap
  {(uint8_t*)"\xe9\xfd\x5d\xd5\xff\x5b\xf2\x4c\x9b\x43\xd8\x9e\xcd\xba\x57\xbc\x54\xf6\x3b\x25\xa5\xf6\x4e\x03\xf1\x4c\x61\x6d\x43\x1a\x7f\xd8", (void(*)(void *))&fexfn_unpack_libdrm_drmGetClient}, // libdrm:drmGetClient
  {(uint8_t*)"\x9d\xaa\x3c\x81\x61\x84\xd1\xee\xcc\x44\x9f\x7c\x05\x03\x89\x51\xf4\x6f\x9a\xd9\xec\xac\xc7\x6c\xea\xb8\x57\xa0\x58\x93\xc5\x0c", (void(*)(void *))&fexfn_unpack_libdrm_drmGetStats}, // libdrm:drmGetStats
  {(uint8_t*)"\x6c\x27\xb8\xf7\x59\x35\xb7\xa1\x65\x92\xff\xde\x66\x58\x10\x26\xb7\xd1\x1d\xac\x43\x32\xec\xaf\xeb\x2c\xc0\x80\x8b\x34\x55\x3d", (void(*)(void *))&fexfn_unpack_libdrm_drmSetInterfaceVersion}, // libdrm:drmSetInterfaceVersion
  {(uint8_t*)"\xf1\x14\x79\x71\x98\x00\x4f\x3f\x41\x19\x61\xf1\x47\xd4\xfe\x07\xba\xef\xf3\x2f\xfb\x7c\x88\x4a\x45\xf3\x8c\xcc\x9b\x51\xaa\x11", (void(*)(void *))&fexfn_unpack_libdrm_drmCommandNone}, // libdrm:drmCommandNone
  {(uint8_t*)"\x0b\x10\x79\xf8\x3e\x4b\xf3\x1b\x9d\x1b\x69\xe9\xa0\xdd\x74\x55\xbb\x35\x3f\x03\x80\xff\x0b\x10\xe5\xfc\x23\x29\x56\x14\x6b\x86", (void(*)(void *))&fexfn_unpack_libdrm_drmCommandRead}, // libdrm:drmCommandRead
  {(uint8_t*)"\x2f\x60\x41\x03\x87\xb4\x5c\x36\xc7\x4f\x78\xb2\x1d\x94\x1e\xdd\x77\xac\x11\x2c\x0b\xc9\xcc\x1a\x71\x6f\x4f\x20\xd5\xba\x7e\x05", (void(*)(void *))&fexfn_unpack_libdrm_drmCommandWrite}, // libdrm:drmCommandWrite
  {(uint8_t*)"\xf1\xa7\x2c\x82\x12\x39\x8f\xef\x5c\x9c\x14\x95\x8a\x2b\x22\x8a\x92\x71\x9e\xa2\x5d\xd6\x3d\xc4\xed\xa9\xe4\x90\x8a\x3b\xf1\xb6", (void(*)(void *))&fexfn_unpack_libdrm_drmCommandWriteRead}, // libdrm:drmCommandWriteRead
  {(uint8_t*)"\x34\xee\x68\x25\xe8\x4a\x0c\xda\x37\x6a\xff\x27\xe0\x4a\x93\x2e\xb6\x58\xe0\x45\x4a\x72\x1b\xa1\xc3\x68\x89\x6f\x4f\x1c\x68\xe4", (void(*)(void *))&fexfn_unpack_libdrm_drmFreeBusid}, // libdrm:drmFreeBusid
  {(uint8_t*)"\xc6\x1d\x9d\xe9\xac\x46\xf4\x53\x18\x6f\x61\xb8\xb6\xac\xe0\x77\x17\xbc\xbd\x05\x70\xdf\x5e\x8c\x92\x40\x48\xe2\x56\xcd\x87\x7c", (void(*)(void *))&fexfn_unpack_libdrm_drmSetBusid}, // libdrm:drmSetBusid
  {(uint8_t*)"\xa7\x1f\xc4\x7e\xad\xcd\xac\x0a\xda\x8b\x6f\x66\x30\xed\xc7\x48\x67\x21\x2a\x88\x80\x30\x74\xc2\x4c\xb2\x43\x16\x6b\x23\xfe\xec", (void(*)(void *))&fexfn_unpack_libdrm_drmAuthMagic}, // libdrm:drmAuthMagic
  {(uint8_t*)"\x88\xee\x90\xb9\x41\xe8\xc7\x18\x25\xdc\x69\xdc\x4e\x15\x77\x59\xe5\x00\x67\x90\x09\x47\xcf\xb1\xb9\x9d\xaf\x17\x7c\xca\xae\x49", (void(*)(void *))&fexfn_unpack_libdrm_drmAddMap}, // libdrm:drmAddMap
  {(uint8_t*)"\x0d\x01\xc9\xa5\xd2\x8a\x99\xbb\x89\x8e\x23\x15\xed\x74\x3b\x58\xec\xc7\x12\xce\x5c\x40\xa9\x40\xda\x8e\x58\xfa\x10\x52\xa3\x20", (void(*)(void *))&fexfn_unpack_libdrm_drmRmMap}, // libdrm:drmRmMap
  {(uint8_t*)"\xff\x75\x46\xfa\xd7\x8c\x82\x1f\x3d\xe6\x83\x5b\x86\xcf\x55\xeb\xaa\x52\x89\x6b\xb8\x90\x83\x19\x98\x29\x2d\xaa\x5c\x71\xc6\x03", (void(*)(void *))&fexfn_unpack_libdrm_drmAddContextPrivateMapping}, // libdrm:drmAddContextPrivateMapping
  {(uint8_t*)"\x34\x38\xbf\x23\x08\xaf\x2c\x21\x1d\xac\xcc\xfa\x3f\x28\xd4\x83\xd8\x1a\xef\xf3\xe2\xd1\xba\x0d\x40\x13\xcb\xf5\xc5\xc3\x6e\x5a", (void(*)(void *))&fexfn_unpack_libdrm_drmAddBufs}, // libdrm:drmAddBufs
  {(uint8_t*)"\xa7\x86\x0b\x22\x97\x53\xc3\x42\xac\x9b\xcb\xb5\xfb\x1c\x3d\xfc\x79\x63\x94\xca\xfd\x4f\x17\xd9\xd1\xf1\x2e\x7f\xf9\x77\x64\x49", (void(*)(void *))&fexfn_unpack_libdrm_drmMarkBufs}, // libdrm:drmMarkBufs
  {(uint8_t*)"\xfb\xf7\x0e\xc5\x26\x63\xcd\xe1\xc1\x51\xdf\x04\x2f\x78\x3d\x44\xc7\x8c\xf9\x65\x78\xe9\xf0\x67\x8b\x99\xd0\xfb\x6b\xd5\x62\x9c", (void(*)(void *))&fexfn_unpack_libdrm_drmCreateContext}, // libdrm:drmCreateContext
  {(uint8_t*)"\x75\x8a\x39\x43\xa0\xe5\x07\xc5\xd5\x9c\xea\x16\x44\x42\x5e\x2d\xa9\x26\xfa\xea\x87\xe3\xc0\x0f\x8a\x9d\x86\x9f\xe9\x92\x97\xcd", (void(*)(void *))&fexfn_unpack_libdrm_drmSetContextFlags}, // libdrm:drmSetContextFlags
  {(uint8_t*)"\xc4\x51\xd8\xe8\x1d\x08\x0b\xfd\xbf\x18\x8e\xd1\xa5\xf3\xb3\x43\x57\x2a\x25\x42\x56\x22\x33\xb1\x1b\x8a\xfe\xd2\x1c\x74\x89\xcc", (void(*)(void *))&fexfn_unpack_libdrm_drmGetContextFlags}, // libdrm:drmGetContextFlags
  {(uint8_t*)"\x0c\x80\xb1\x05\xb4\xe3\xd6\x54\x4b\xff\xce\x41\xb0\x96\x5c\x2a\xca\x16\x55\xca\x54\x4f\x27\xf9\xb3\x39\xd5\xfd\x71\x89\x1c\xe1", (void(*)(void *))&fexfn_unpack_libdrm_drmAddContextTag}, // libdrm:drmAddContextTag
  {(uint8_t*)"\x4b\x09\x57\x23\xed\xf7\x7b\x3d\x2a\xef\x1e\x91\x1f\x12\x4d\x80\x7e\x41\x20\x3e\x68\x88\x1a\x9c\x77\x10\xae\x92\x26\xee\x26\x12", (void(*)(void *))&fexfn_unpack_libdrm_drmDelContextTag}, // libdrm:drmDelContextTag
  {(uint8_t*)"\x60\x7a\x2d\xb4\xa1\xfa\x46\xd9\x75\x48\x46\xcd\x99\x54\x2d\x97\x27\xf1\x8c\x0b\x3f\x33\x92\x7e\x24\x72\x4a\x8a\xe3\x13\x02\xa8", (void(*)(void *))&fexfn_unpack_libdrm_drmGetContextTag}, // libdrm:drmGetContextTag
  {(uint8_t*)"\x95\x9b\xe8\x1b\xd3\xd3\xe1\xa4\x00\xca\x8e\x2c\x74\xba\x54\x41\x90\x4f\xbc\x47\xa4\xe0\x29\x68\xaa\xed\x9a\xc6\x3a\xef\xbe\x8b", (void(*)(void *))&fexfn_unpack_libdrm_drmGetReservedContextList}, // libdrm:drmGetReservedContextList
  {(uint8_t*)"\x00\x1a\xf0\x63\x63\x34\xe6\x1e\x78\x1b\x4d\x6b\x1e\x90\x31\x31\xff\x13\x8d\xfd\xc3\x10\x8d\xd2\x12\xe8\xa9\x02\xe6\x2d\x9d\x81", (void(*)(void *))&fexfn_unpack_libdrm_drmFreeReservedContextList}, // libdrm:drmFreeReservedContextList
  {(uint8_t*)"\xd7\x91\xd9\xf0\x6e\x85\xc9\xa1\x59\x89\x82\x6e\xed\xda\xef\x6a\x0e\x77\xae\xe2\x73\x28\x7d\x0b\x65\x9d\xa5\x4b\x74\xf6\x22\xd5", (void(*)(void *))&fexfn_unpack_libdrm_drmSwitchToContext}, // libdrm:drmSwitchToContext
  {(uint8_t*)"\x2d\x63\xf2\x6c\x1f\xb5\xec\x12\xff\x07\x1d\x91\xbd\xff\xbe\xcc\x1a\x99\x38\x57\x9e\x78\x3c\x07\x68\xa4\x4c\x47\xd1\xf0\x90\x1e", (void(*)(void *))&fexfn_unpack_libdrm_drmDestroyContext}, // libdrm:drmDestroyContext
  {(uint8_t*)"\xea\x18\x44\x72\xd2\xdb\x9f\x93\x91\x4e\xcb\x22\x71\xff\x45\xe5\x75\x9a\x67\x51\xd2\xf3\x69\xbd\x87\xd7\x6f\xf9\xca\xd6\x19\x23", (void(*)(void *))&fexfn_unpack_libdrm_drmCreateDrawable}, // libdrm:drmCreateDrawable
  {(uint8_t*)"\x7c\x96\x8e\x1f\xc2\x51\x7b\x89\xc6\xd2\xc8\xf6\xbf\xdd\x2a\xe2\xe5\x94\x94\x34\xf6\x89\x9d\xee\x56\x34\x29\x12\xe7\xf3\xf8\x85", (void(*)(void *))&fexfn_unpack_libdrm_drmDestroyDrawable}, // libdrm:drmDestroyDrawable
  {(uint8_t*)"\xe3\xc7\x57\x21\x23\x8d\x36\x16\x85\xfd\x56\xc8\x22\x51\x13\xcc\x15\x7f\x99\xa0\xe5\x81\xd0\x31\xac\xca\xbe\x17\xd5\xa1\xb7\x30", (void(*)(void *))&fexfn_unpack_libdrm_drmUpdateDrawableInfo}, // libdrm:drmUpdateDrawableInfo
  {(uint8_t*)"\xad\x3d\x35\x54\x1d\x8b\x85\x6a\x0a\x6c\xd3\xce\x9e\x82\xee\x3e\x06\x10\xa0\x6c\x5e\x68\xed\xcf\xc6\x79\x83\x23\x20\xff\x0a\xf1", (void(*)(void *))&fexfn_unpack_libdrm_drmCtlInstHandler}, // libdrm:drmCtlInstHandler
  {(uint8_t*)"\xa1\x13\x35\xa3\x03\x1c\x79\xad\xbf\xde\xe6\xb3\xe3\x45\x5f\x10\x8f\x09\x60\x23\x11\x42\x9c\x32\xfc\x41\x1f\x86\x23\x42\x40\x05", (void(*)(void *))&fexfn_unpack_libdrm_drmCtlUninstHandler}, // libdrm:drmCtlUninstHandler
  {(uint8_t*)"\x18\x19\x77\xe6\x86\x13\x9e\xa7\xc0\x40\x37\x87\x4b\x44\xbc\x68\x54\xdc\xd4\x77\x84\xd4\x06\xc3\xab\x8a\xc3\x6a\x6e\xa0\x13\x6c", (void(*)(void *))&fexfn_unpack_libdrm_drmSetClientCap}, // libdrm:drmSetClientCap
  {(uint8_t*)"\x8f\x15\xc0\x30\x8b\x99\xba\x48\x57\x0c\x51\x3b\x44\x76\xde\x35\x5e\x67\xdf\xc3\xf9\xbf\xec\x8b\xf8\x21\x80\xd1\x3e\xf6\xb4\x81", (void(*)(void *))&fexfn_unpack_libdrm_drmCrtcGetSequence}, // libdrm:drmCrtcGetSequence
  {(uint8_t*)"\x85\xde\x33\xde\xc6\x1e\x09\x62\xb2\x66\xcc\x30\x3b\x35\x28\xcb\xd9\x9a\xfa\x96\x65\xef\x3c\x76\x12\x69\x99\xcb\x85\x97\x28\x95", (void(*)(void *))&fexfn_unpack_libdrm_drmCrtcQueueSequence}, // libdrm:drmCrtcQueueSequence
  {(uint8_t*)"\x5b\x6e\x4e\xb7\x37\x4c\xe1\x9a\x88\x58\xf1\x86\xb7\x6e\x0e\xca\x7a\x9d\x0b\x00\xa3\x0c\x7d\x28\x2e\x77\xab\x2b\xa3\xdc\xc7\x0e", (void(*)(void *))&fexfn_unpack_libdrm_drmMap}, // libdrm:drmMap
  {(uint8_t*)"\xdf\x46\x01\x42\x22\xf2\x2c\x01\x12\x71\x6f\xe9\x73\xae\x45\xfb\x2c\x38\x68\x2c\xb9\xcd\xc7\x9b\xeb\x73\xbf\x96\xc3\xa5\xe6\x6d", (void(*)(void *))&fexfn_unpack_libdrm_drmUnmap}, // libdrm:drmUnmap
  {(uint8_t*)"\x15\x60\x43\x40\xd2\x85\x88\xaa\xff\x9b\x89\x97\xd0\x85\x4d\x0c\x51\xde\x65\x55\x1b\xd0\x6f\x3b\xf1\xf3\x38\xf6\x76\x5a\xd4\x09", (void(*)(void *))&fexfn_unpack_libdrm_drmGetBufInfo}, // libdrm:drmGetBufInfo
  {(uint8_t*)"\xa1\x7d\x01\x14\x01\x77\x33\x86\x77\x3b\x6d\x25\x0a\xb0\x83\xd6\xc3\xd0\x47\xf5\x6e\x97\x4e\xad\x0c\xda\x6c\xb8\x97\x50\x60\x9e", (void(*)(void *))&fexfn_unpack_libdrm_drmMapBufs}, // libdrm:drmMapBufs
  {(uint8_t*)"\xa7\x7d\x14\xab\x79\x73\xe6\x2a\x8e\xd7\x97\x32\xf6\x30\x37\x94\x09\x7e\x7d\x2a\xe7\xd0\x03\xad\x8e\xdd\x94\xda\x1d\x4d\xc9\x18", (void(*)(void *))&fexfn_unpack_libdrm_drmUnmapBufs}, // libdrm:drmUnmapBufs
  {(uint8_t*)"\xc6\xe9\x90\x05\xc8\xbe\xdb\x09\x25\x02\x4a\x6a\xaa\x5f\xc2\xe5\x59\xb5\x87\x24\xa0\xb5\x1c\xb5\x91\x6b\x04\xb3\xf8\x46\x8c\x48", (void(*)(void *))&fexfn_unpack_libdrm_drmDMA}, // libdrm:drmDMA
  {(uint8_t*)"\xf7\x3d\x2e\x43\x62\x93\xb0\x79\x06\x96\x2c\x5c\xd1\x24\xc9\xd5\x18\x78\x94\x81\xc4\x20\x09\x9a\xcc\x74\xac\x0f\xb9\x0b\xfd\xd3", (void(*)(void *))&fexfn_unpack_libdrm_drmFreeBufs}, // libdrm:drmFreeBufs
  {(uint8_t*)"\x21\x20\x03\x48\xb4\xd6\xfe\xde\x90\x8e\xf7\xc9\x0e\xc4\xe5\x34\xeb\x80\x68\xee\x48\xb0\x7a\x1b\x6d\x18\x2e\xf5\xe0\x61\x2e\xb8", (void(*)(void *))&fexfn_unpack_libdrm_drmGetLock}, // libdrm:drmGetLock
  {(uint8_t*)"\x55\x04\xa7\x13\x92\x47\x7a\x88\xed\xe6\x13\xbf\xd0\xdf\x90\xf7\xd4\x08\x54\xad\xc7\xb7\x4a\x84\x41\x0e\x93\x66\x8f\x35\x6b\x08", (void(*)(void *))&fexfn_unpack_libdrm_drmUnlock}, // libdrm:drmUnlock
  {(uint8_t*)"\x25\xc4\xd6\x79\x5a\x1d\x17\xc8\x37\x8b\xcc\x08\x46\x45\xba\x04\x2a\x06\x0b\x01\x6d\xf0\x85\xe3\x16\x88\x22\x9e\xc0\x44\x5c\x21", (void(*)(void *))&fexfn_unpack_libdrm_drmFinish}, // libdrm:drmFinish
  {(uint8_t*)"\xa4\xd8\xcf\xba\x05\x7e\x72\x83\x64\x87\x1e\xef\x53\xf5\x2a\xe4\xa0\xfc\xd2\xb3\x60\xfc\xb3\x1b\x2d\x72\x50\x5c\xb7\xa0\x50\x0f", (void(*)(void *))&fexfn_unpack_libdrm_drmGetContextPrivateMapping}, // libdrm:drmGetContextPrivateMapping
  {(uint8_t*)"\x5e\xa9\x98\x83\x21\x08\xf3\x36\x4c\xfe\x09\xe7\x93\xf6\x63\xd0\x13\xd2\xb0\x42\xe1\x95\x65\x41\x55\xa8\x1d\x9e\x99\xfe\xab\x7b", (void(*)(void *))&fexfn_unpack_libdrm_drmScatterGatherAlloc}, // libdrm:drmScatterGatherAlloc
  {(uint8_t*)"\x22\x69\x81\x46\x34\xaa\xd2\x98\xe1\x2c\xea\xda\x50\xc0\xb2\x57\x9b\x4b\x5a\x43\x70\x1a\x15\x02\x83\x8a\x9d\x80\xbd\x79\x38\x48", (void(*)(void *))&fexfn_unpack_libdrm_drmScatterGatherFree}, // libdrm:drmScatterGatherFree
  {(uint8_t*)"\x08\x3a\x8d\x0d\xe8\x48\x9f\x9e\x29\xeb\x89\x74\x75\x62\x9c\x2e\xc1\x4f\xc5\x70\x1b\xad\xc0\xe7\xdf\x6c\xba\xe7\x2b\xe1\x62\x0e", (void(*)(void *))&fexfn_unpack_libdrm_drmWaitVBlank}, // libdrm:drmWaitVBlank
  {(uint8_t*)"\x0b\xc7\x66\x69\x28\x8a\x8e\x1b\xce\xb3\xe2\x0c\x55\x34\x35\xb1\x2b\x84\xa4\xff\xe2\x99\xac\x67\xa8\x5b\xda\xe1\xd3\xe3\xa2\xa2", (void(*)(void *))&fexfn_unpack_libdrm_drmSetServerInfo}, // libdrm:drmSetServerInfo
  {(uint8_t*)"\x88\x33\x6e\xb0\xff\x73\xa3\x58\x3f\xef\xfd\x15\x41\xea\x42\x2c\x00\xf1\xec\x7f\x2e\xbb\xe4\x3a\x0a\x26\x8c\x03\xec\xbf\x7c\xce", (void(*)(void *))&fexfn_unpack_libdrm_drmError}, // libdrm:drmError
  {(uint8_t*)"\x70\x9d\x5f\x7e\xee\x91\x23\x29\xb3\xd3\x86\xfb\x0d\xe5\x47\x8b\xa3\x4b\x63\x7d\x87\x55\x64\x18\x9a\x8b\x52\xd4\x51\x41\xc5\x25", (void(*)(void *))&fexfn_unpack_libdrm_drmMalloc}, // libdrm:drmMalloc
  {(uint8_t*)"\x95\x63\x81\xef\xe1\x10\xef\x73\x7b\xd3\x67\x08\xd6\xca\xfb\x77\x07\xe1\xae\x08\x5a\x3f\x65\xa0\x47\x52\xaf\x79\x83\x7f\x4c\x31", (void(*)(void *))&fexfn_unpack_libdrm_drmFree}, // libdrm:drmFree
  {(uint8_t*)"\x6f\x1a\x00\xba\x37\x0c\x52\xde\xb8\x77\x61\x0e\xc0\x36\xdd\x2b\x87\x83\x72\x35\xa4\x10\x13\xcb\xd4\xe1\x25\x12\xd0\x98\xd5\x03", (void(*)(void *))&fexfn_unpack_libdrm_drmHashCreate}, // libdrm:drmHashCreate
  {(uint8_t*)"\xac\xe0\x16\xb5\x86\x82\x5c\xd2\xc4\xe2\xef\x16\xa0\x21\xde\xea\x65\x02\x1d\x2b\x0a\x52\xdc\x9a\x2c\x83\xb9\x90\xb1\x3d\xf5\x13", (void(*)(void *))&fexfn_unpack_libdrm_drmHashDestroy}, // libdrm:drmHashDestroy
  {(uint8_t*)"\xb9\x1e\x4d\x3d\x76\x37\x0e\xfe\xb7\xfc\xc3\x3c\x74\xc9\xd1\x4c\x3c\xd2\xa4\xcf\x1e\xdc\x24\x6c\x55\x1c\xb8\x9c\xab\xe7\xbd\x07", (void(*)(void *))&fexfn_unpack_libdrm_drmHashLookup}, // libdrm:drmHashLookup
  {(uint8_t*)"\xa2\x2d\x47\x6a\x61\x2f\xf0\x9d\x59\x44\xf8\x21\xe5\xa6\x79\xa5\x43\x90\x5b\x60\xa9\xbe\xb0\x3d\x6f\x45\x64\x98\xaf\x33\xc6\x18", (void(*)(void *))&fexfn_unpack_libdrm_drmHashInsert}, // libdrm:drmHashInsert
  {(uint8_t*)"\xea\xd6\x7b\xdd\x74\x65\x91\x3c\xeb\x2c\x7f\xb1\x53\x4c\x52\x7e\x3b\x4f\x74\x88\xcc\xb9\x4c\x05\x74\x0e\x69\x53\xec\xe6\x9e\xd2", (void(*)(void *))&fexfn_unpack_libdrm_drmHashDelete}, // libdrm:drmHashDelete
  {(uint8_t*)"\xe1\xa2\x69\x6f\x82\x4e\x26\x95\xed\xdf\x59\x31\x08\x08\x90\x0d\x8e\x9c\x84\x9d\x9b\x6d\x4c\x20\xc3\xf1\x1f\x70\x80\xab\xb7\x0b", (void(*)(void *))&fexfn_unpack_libdrm_drmHashFirst}, // libdrm:drmHashFirst
  {(uint8_t*)"\xfc\x39\x69\xe5\xcf\x5e\x2d\xb7\x5e\xfc\x5a\x0d\x0c\x12\xb4\x14\x6b\xd9\xb9\x00\x82\x44\x6e\xac\x06\x42\xc6\xa7\xa1\x06\x48\xd4", (void(*)(void *))&fexfn_unpack_libdrm_drmHashNext}, // libdrm:drmHashNext
  {(uint8_t*)"\xf5\x73\x1a\x78\xae\xbe\x9d\xfd\x44\x1e\xcb\xd6\x64\xe8\xd6\xfb\x73\xb1\xa2\x1c\x52\x50\xe0\xb0\x0e\xfa\x81\x61\x8e\xb7\xbc\xb7", (void(*)(void *))&fexfn_unpack_libdrm_drmRandomCreate}, // libdrm:drmRandomCreate
  {(uint8_t*)"\x43\xc1\xd7\xab\xf9\xb1\x00\xf0\xf7\x09\x6e\x87\xa0\xe1\x82\xab\xa9\x47\xdf\xff\x3d\xa1\x17\x65\xe8\xed\x55\x93\x19\xe0\x5c\x3d", (void(*)(void *))&fexfn_unpack_libdrm_drmRandomDestroy}, // libdrm:drmRandomDestroy
  {(uint8_t*)"\x6f\xaf\xd1\x1b\x99\x55\xa5\xbc\xa1\x88\x28\x5c\x30\xab\x63\x40\x15\xc5\x05\xc9\x36\xf4\x64\x84\xd4\x51\x19\xa3\x9a\x1a\x65\x4c", (void(*)(void *))&fexfn_unpack_libdrm_drmRandom}, // libdrm:drmRandom
  {(uint8_t*)"\x86\x0d\x86\xd7\xbb\x64\xcf\x6d\x78\x16\x89\x52\x14\xde\xfc\xc5\x7b\xb2\x7e\xe4\x6a\xe4\xf6\xb4\xe3\x0a\x27\xca\x05\x82\x8d\x15", (void(*)(void *))&fexfn_unpack_libdrm_drmRandomDouble}, // libdrm:drmRandomDouble
  {(uint8_t*)"\x2f\x62\x65\x82\x3c\x18\xd9\x2e\xd9\x0a\x07\x52\x83\xdb\x65\x96\x00\x77\x58\x99\xc7\x12\x5b\xda\x0a\xc6\x30\xb0\x98\xda\x78\xc8", (void(*)(void *))&fexfn_unpack_libdrm_drmSLCreate}, // libdrm:drmSLCreate
  {(uint8_t*)"\x3b\x91\x49\xca\xd7\xf5\x77\x5d\xee\x43\xc6\x6a\x4a\x44\xb1\x17\x90\x37\xb3\xd0\xe0\x55\xce\xf4\xdb\x35\x29\x0f\x8f\xd3\xa9\xc6", (void(*)(void *))&fexfn_unpack_libdrm_drmSLDestroy}, // libdrm:drmSLDestroy
  {(uint8_t*)"\xbf\x00\x39\x39\x45\xc2\x6c\xb5\xe3\x46\xa3\x2d\x8b\xda\xd9\x1b\x55\x28\x91\xb7\xf7\xa3\x2e\x3e\x8e\x82\xca\x12\x49\x20\x46\xdf", (void(*)(void *))&fexfn_unpack_libdrm_drmSLLookup}, // libdrm:drmSLLookup
  {(uint8_t*)"\xda\x62\x39\xd9\x52\xbc\xd0\xcd\xeb\x78\xdf\xe7\x67\xba\x7f\x62\x22\x8d\x8f\xfa\x8d\x20\xb1\x3e\xea\x15\x4c\xf1\xdc\x9a\xb2\x77", (void(*)(void *))&fexfn_unpack_libdrm_drmSLInsert}, // libdrm:drmSLInsert
  {(uint8_t*)"\x98\xf6\x2a\x62\xa9\x60\x69\x28\xfa\xe2\xa7\x49\x6a\x1a\xe7\x52\x64\xa2\xc3\x79\x14\x66\xab\x75\x6d\x34\x1b\xab\x15\x6f\x76\xe1", (void(*)(void *))&fexfn_unpack_libdrm_drmSLDelete}, // libdrm:drmSLDelete
  {(uint8_t*)"\x00\xd5\x6e\x33\xed\x4d\x3d\x81\x56\x1e\xae\x9d\x56\xc5\x08\x9f\x4c\xc4\xcd\x90\xbd\xb8\x7d\x17\x0b\x30\x87\x5a\xe9\xa6\xeb\xba", (void(*)(void *))&fexfn_unpack_libdrm_drmSLNext}, // libdrm:drmSLNext
  {(uint8_t*)"\xa6\xd1\xc5\xf6\xc0\xe8\x66\x49\xe4\x5d\xd5\x09\x4d\x5c\x9d\x53\x61\xf1\x77\x8f\xec\x6a\x6c\x56\xcc\xbf\xec\x70\x49\x4c\x43\x53", (void(*)(void *))&fexfn_unpack_libdrm_drmSLFirst}, // libdrm:drmSLFirst
  {(uint8_t*)"\x17\xac\xee\xfc\x2d\xb4\x71\xed\x2e\x45\xd8\x78\xd9\xf4\xb6\xf1\xaa\xfe\x3d\x6e\x32\x90\xe1\x16\x49\xcc\x1e\xe1\x08\x88\x77\x32", (void(*)(void *))&fexfn_unpack_libdrm_drmSLDump}, // libdrm:drmSLDump
  {(uint8_t*)"\x07\x07\xd1\x77\xa1\x5a\x6d\xd3\xef\x52\x2b\xc2\x5b\xeb\xf9\x65\xc9\x93\x75\x1e\xa4\x0a\x81\xbb\x25\x78\xde\x1f\x34\xcb\xd2\x6c", (void(*)(void *))&fexfn_unpack_libdrm_drmSLLookupNeighbors}, // libdrm:drmSLLookupNeighbors
  {(uint8_t*)"\xa6\x04\x01\x72\x06\xab\x6f\xdd\x06\x15\x4a\x8a\xb7\x45\x24\x1b\xea\x4f\xc3\x76\x7d\x00\x90\xab\xc2\xd3\x7d\xed\xad\x62\x3a\x7c", (void(*)(void *))&fexfn_unpack_libdrm_drmOpenOnce}, // libdrm:drmOpenOnce
  {(uint8_t*)"\x0e\x23\xe2\x15\xa0\x0d\xa2\x90\x74\xea\xb0\xf6\x4c\x5c\xe4\xa5\x51\x50\x64\x20\x40\x72\x18\x07\x0d\xa7\x01\xff\x40\x2f\x32\x0e", (void(*)(void *))&fexfn_unpack_libdrm_drmOpenOnceWithType}, // libdrm:drmOpenOnceWithType
  {(uint8_t*)"\xbd\x29\xc6\xbb\xd1\x52\x4f\xa7\x4b\x88\x82\xd6\xbd\x1e\xd1\x2f\x50\x8a\xbd\xdf\x1c\xef\xbb\x7d\x0c\x47\xc8\xbf\x05\x9b\x11\x63", (void(*)(void *))&fexfn_unpack_libdrm_drmCloseOnce}, // libdrm:drmCloseOnce
  {(uint8_t*)"\x66\xd6\xb1\xc9\xf2\x75\xbc\xd4\xc7\x31\x47\x69\x70\x42\xd5\x80\xda\x96\xf1\x2c\x0a\x97\x5b\x4e\x93\xa0\xc0\x60\x27\x60\xf7\x27", (void(*)(void *))&fexfn_unpack_libdrm_drmSetMaster}, // libdrm:drmSetMaster
  {(uint8_t*)"\xbf\x00\x17\x81\x8e\x79\xac\xc0\x57\xd4\x3d\xb0\x9d\x3c\xd2\x82\x2c\x61\x6e\xfa\xbe\xdd\xb0\x93\xc4\x2a\x70\xbb\x58\x39\xf1\x8c", (void(*)(void *))&fexfn_unpack_libdrm_drmDropMaster}, // libdrm:drmDropMaster
  {(uint8_t*)"\x99\x77\xa2\xcc\xef\xaf\x24\x95\xee\xe8\xb6\x8d\x6d\xeb\x00\xf0\x37\x05\x08\xd8\x93\xdf\x32\x24\x28\xd2\xb8\x36\x69\xca\x64\x7d", (void(*)(void *))&fexfn_unpack_libdrm_drmIsMaster}, // libdrm:drmIsMaster
  {(uint8_t*)"\xd8\x01\x09\xa8\x74\x87\x1d\x8f\xbc\xd5\x58\x63\x60\xf9\xb7\x71\xd0\xba\x73\xbc\xbd\x49\x75\x9f\xf2\x9d\x39\xc3\x7a\x73\x9b\x5f", (void(*)(void *))&fexfn_unpack_libdrm_drmHandleEvent}, // libdrm:drmHandleEvent
  {(uint8_t*)"\x18\xe0\x82\x49\x73\xa8\x5b\xd5\xea\xdb\x1c\xdc\x63\x99\x8b\x40\x95\xbc\x43\xfa\x5a\xb7\xb5\xd1\x8f\x11\xbd\x16\xe1\x0c\x56\xd8", (void(*)(void *))&fexfn_unpack_libdrm_drmGetDeviceNameFromFd}, // libdrm:drmGetDeviceNameFromFd
  {(uint8_t*)"\xa8\xf4\xb0\xdf\xeb\x1c\x1e\x0c\x6e\x3f\x3e\xaf\x97\x1f\xb4\xf4\xb6\xcb\xeb\x26\x7d\xb9\x14\xce\x7e\x8f\x4d\x9e\x12\xd0\x6c\x8a", (void(*)(void *))&fexfn_unpack_libdrm_drmGetDeviceNameFromFd2}, // libdrm:drmGetDeviceNameFromFd2
  {(uint8_t*)"\x23\x01\xb1\x69\x25\xf8\x57\x2f\xe4\xdf\xc5\x96\xcc\x97\x40\xb2\x44\xae\x0e\x3c\xf0\xab\xc5\x5e\xa8\x7e\xc0\x21\x5e\xf6\x7d\x52", (void(*)(void *))&fexfn_unpack_libdrm_drmGetNodeTypeFromFd}, // libdrm:drmGetNodeTypeFromFd
  {(uint8_t*)"\x5d\x3f\xcb\x8c\x64\x03\xdf\xff\xfb\x15\x09\xad\x91\xda\x9a\x49\xfa\x30\x1d\x0a\x7c\x3f\x01\xa2\x59\xae\x35\x60\x04\xea\xab\xe9", (void(*)(void *))&fexfn_unpack_libdrm_drmPrimeHandleToFD}, // libdrm:drmPrimeHandleToFD
  {(uint8_t*)"\xde\xc9\x6b\x83\x32\xb8\x6a\x67\xa5\xf7\xb8\xd8\x74\x2c\xab\x2a\x4f\x8e\x85\x18\x73\xc8\x55\x26\xa4\x86\xe9\x6a\xe3\x09\x83\x75", (void(*)(void *))&fexfn_unpack_libdrm_drmPrimeFDToHandle}, // libdrm:drmPrimeFDToHandle
  {(uint8_t*)"\x86\xc5\x93\x5e\xc3\xd6\x24\x2c\xe2\x19\x96\x26\x2a\x6b\x4a\x9b\x4e\x5e\x86\x93\x6b\xc4\x00\xe9\x77\x73\x47\xf6\x27\xfc\x16\x7d", (void(*)(void *))&fexfn_unpack_libdrm_drmGetPrimaryDeviceNameFromFd}, // libdrm:drmGetPrimaryDeviceNameFromFd
  {(uint8_t*)"\x5d\x6a\x91\xf9\x23\x10\x8c\x43\x02\xc5\x69\x3f\xd9\xb0\x3e\x8d\x7f\x8f\xa1\xfe\xe7\xeb\x67\xe7\xeb\x3c\xd9\xa9\xa4\x68\xdf\x06", (void(*)(void *))&fexfn_unpack_libdrm_drmGetRenderDeviceNameFromFd}, // libdrm:drmGetRenderDeviceNameFromFd
  {(uint8_t*)"\xd7\xd9\x7d\x8c\xdd\xfd\x75\x0b\x30\x7d\xb2\x82\xfa\xa1\xe1\x6f\xbe\x20\xed\x39\xe5\xd6\xfc\x4a\x8b\x1b\x7e\x3c\x07\xf8\x4b\x94", (void(*)(void *))&fexfn_unpack_libdrm_drmGetDevice}, // libdrm:drmGetDevice
  {(uint8_t*)"\x8b\xb3\xb6\xd2\x26\xc6\x98\xd9\x42\x82\x2b\x11\xf0\x24\x72\x9a\xaf\x4e\x5e\xbf\x8d\x63\x50\xf5\x4a\xa1\x39\x81\xa5\x39\x18\x6e", (void(*)(void *))&fexfn_unpack_libdrm_drmFreeDevice}, // libdrm:drmFreeDevice
  {(uint8_t*)"\x2a\xa5\x3d\x56\x4a\x8c\x8b\xc0\x68\xc5\xa8\x7f\x90\x4d\x89\xac\x85\x72\x8d\xbf\xdf\xde\x02\x9f\x16\x79\x12\x6c\x2e\xd7\x7e\xb6", (void(*)(void *))&fexfn_unpack_libdrm_drmGetDevices}, // libdrm:drmGetDevices
  {(uint8_t*)"\xdb\x7b\x6c\x4f\x37\xd6\x35\x28\xb2\x1c\x1c\x97\x72\x03\xcd\xe9\x7c\x52\x19\x9b\x94\x3c\x79\x94\x32\x2e\xa3\x0e\x1f\x64\x9d\x69", (void(*)(void *))&fexfn_unpack_libdrm_drmFreeDevices}, // libdrm:drmFreeDevices
  {(uint8_t*)"\x90\xda\x03\xf7\x63\x7b\xda\x3d\x57\x63\xf7\x16\x3b\xb6\x9f\x45\xb4\x47\xd3\x74\x74\x09\x5b\x05\x70\xd2\x3a\x5b\xc2\x02\x2c\x9f", (void(*)(void *))&fexfn_unpack_libdrm_drmGetDevice2}, // libdrm:drmGetDevice2
  {(uint8_t*)"\x41\xf7\x81\xa3\xba\x81\xae\x84\x3c\xb4\xc9\x1d\x7f\x3f\x2d\x7a\x97\x2e\xc5\x67\x88\xea\xbe\x48\x5b\x0c\x8c\x39\x5a\x59\x58\x5b", (void(*)(void *))&fexfn_unpack_libdrm_drmGetDevices2}, // libdrm:drmGetDevices2
  {(uint8_t*)"\x49\x46\x1b\x63\xc4\xfe\xe0\x49\x77\x83\xe5\x01\x8d\xd6\x71\x0b\x6c\x37\x44\x83\xd5\x74\xd4\xc8\x34\x47\x61\xa8\x9d\x67\x24\x4d", (void(*)(void *))&fexfn_unpack_libdrm_drmDevicesEqual}, // libdrm:drmDevicesEqual
  {(uint8_t*)"\x41\xbe\x6b\x2b\xec\x6a\xca\x5f\xa0\x9a\x19\x00\xa9\x77\x52\x1d\xda\x00\xe6\xa3\xe4\x6d\xd8\x60\x6c\xf7\x86\xf3\x3a\xcc\xe4\x7b", (void(*)(void *))&fexfn_unpack_libdrm_drmSyncobjCreate}, // libdrm:drmSyncobjCreate
  {(uint8_t*)"\x3f\x68\xb8\x3f\xf6\x98\xf2\x7d\xda\x1a\x3a\x9a\x10\xd4\xf8\xe3\xee\x95\xee\xdf\x7a\x5d\xb2\x06\xcf\xf2\x53\x9f\xe0\x42\xff\x32", (void(*)(void *))&fexfn_unpack_libdrm_drmSyncobjDestroy}, // libdrm:drmSyncobjDestroy
  {(uint8_t*)"\xa2\xa4\xb4\x06\x46\x7f\x9d\x3a\x60\x58\xf4\x52\x42\xb4\x4d\x39\x81\x27\x92\xb5\x0f\x7d\xaf\x4b\xbc\xa0\x92\xd4\x85\x59\x25\xbf", (void(*)(void *))&fexfn_unpack_libdrm_drmSyncobjHandleToFD}, // libdrm:drmSyncobjHandleToFD
  {(uint8_t*)"\x40\x05\x7a\x39\x1c\x27\xeb\x52\xdd\x7e\xfd\xf1\x0d\xb5\xd1\x78\x49\x45\x42\x6c\x25\xe5\x8d\xf3\x57\x73\xc5\xf6\x37\xea\xd4\xfa", (void(*)(void *))&fexfn_unpack_libdrm_drmSyncobjFDToHandle}, // libdrm:drmSyncobjFDToHandle
  {(uint8_t*)"\xdd\xac\x97\x11\x37\x5f\xff\xd8\x25\x92\x3f\x51\x1a\xfc\x45\xb2\x45\x4d\x74\x3a\x4e\xea\xad\xb2\xb8\xf8\xec\xac\xa4\xbc\x30\x8d", (void(*)(void *))&fexfn_unpack_libdrm_drmSyncobjImportSyncFile}, // libdrm:drmSyncobjImportSyncFile
  {(uint8_t*)"\xbd\x14\x20\x21\x4b\xac\xc9\xf8\x51\x7b\xfd\x87\x73\xe2\x71\x0c\x5d\xf8\x85\x59\xe6\xc9\x10\x94\x7a\x39\x04\xb9\x2b\x84\xa6\xf9", (void(*)(void *))&fexfn_unpack_libdrm_drmSyncobjExportSyncFile}, // libdrm:drmSyncobjExportSyncFile
  {(uint8_t*)"\x22\x14\x16\xee\x9c\xfe\x3c\x1b\x22\xb1\xdd\xba\x29\x90\x1f\x95\xad\x59\x51\x8c\x78\x52\xde\x58\x34\x65\x6c\x45\x06\x31\x6a\xc0", (void(*)(void *))&fexfn_unpack_libdrm_drmSyncobjWait}, // libdrm:drmSyncobjWait
  {(uint8_t*)"\xd5\x59\x4f\xa0\x95\xc5\x88\x3b\xa1\x01\x0f\x15\x62\x4e\x36\x83\xf1\x5b\xd8\xc7\xc5\x2a\xda\xcb\x12\x1c\x58\x01\x10\x61\x72\x0b", (void(*)(void *))&fexfn_unpack_libdrm_drmSyncobjReset}, // libdrm:drmSyncobjReset
  {(uint8_t*)"\xf5\xc1\xd8\x94\xb6\x50\xfe\xcf\x0f\x22\x8f\x6d\x8d\xd6\x39\xdc\x09\x7e\x25\x69\x2f\x60\x8c\x25\xee\xd3\xe7\x64\xd5\x96\xf6\xa0", (void(*)(void *))&fexfn_unpack_libdrm_drmSyncobjSignal}, // libdrm:drmSyncobjSignal
  {(uint8_t*)"\xf1\xa0\xfb\x4d\x18\x8a\x4e\x1d\x59\x4c\x32\xd2\x0f\x31\xd0\x33\x20\xb7\x48\xf6\x9d\xfc\xd4\xfb\x64\xf1\xae\x09\x0d\x81\x6b\xe6", (void(*)(void *))&fexfn_unpack_libdrm_drmSyncobjTimelineSignal}, // libdrm:drmSyncobjTimelineSignal
  {(uint8_t*)"\xd2\x4b\xd1\x1d\xe6\x50\xe0\x6a\x40\x27\x95\x1d\xe3\x45\x32\x30\x7f\xf2\xb6\xa1\xce\x50\xa4\x8c\xa0\x81\x34\x2f\x40\xf6\x33\xd0", (void(*)(void *))&fexfn_unpack_libdrm_drmSyncobjTimelineWait}, // libdrm:drmSyncobjTimelineWait
  {(uint8_t*)"\x1d\x08\x4c\x42\x1a\xe9\xc1\x42\xf0\xa3\x64\xa3\x6e\xfa\x6d\xe6\x99\x5c\xa9\x09\xfb\xac\xe6\x48\x70\x0c\x9e\x46\x5e\xfc\x12\xc4", (void(*)(void *))&fexfn_unpack_libdrm_drmSyncobjQuery}, // libdrm:drmSyncobjQuery
  {(uint8_t*)"\x4f\x7d\xb8\xdf\xb8\xc7\x39\x01\xfb\x62\xdc\x23\x5d\x2b\xe7\x7a\x90\x4a\x68\xa1\x21\x50\x25\xad\x22\xb3\xc2\xef\xd5\x4e\x35\xf7", (void(*)(void *))&fexfn_unpack_libdrm_drmSyncobjQuery2}, // libdrm:drmSyncobjQuery2
  {(uint8_t*)"\xc5\xc9\x4a\x9b\xc7\xab\xb7\x92\x17\x4a\x8e\xe9\x73\xb4\x86\x4a\xa6\xbb\xd2\xbd\x9e\x85\x30\x32\xe7\xd7\x22\x52\xcf\xda\x16\x6e", (void(*)(void *))&fexfn_unpack_libdrm_drmSyncobjTransfer}, // libdrm:drmSyncobjTransfer
  { nullptr, nullptr }
};
static void* fexldr_ptr_libdrm_so;
extern "C" bool fexldr_init_libdrm() {
  fexldr_ptr_libdrm_so = dlopen("libdrm.so.2", RTLD_GLOBAL | RTLD_LAZY);
  if (!fexldr_ptr_libdrm_so) { return false; }

  (void*&)fexldr_ptr_libdrm_FEX_usable_size = dlsym_default(fexldr_ptr_libdrm_so, "FEX_usable_size");
  (void*&)fexldr_ptr_libdrm_FEX_free_on_host = dlsym_default(fexldr_ptr_libdrm_so, "FEX_free_on_host");
  (void*&)fexldr_ptr_libdrm_drmIoctl = dlsym_default(fexldr_ptr_libdrm_so, "drmIoctl");
  (void*&)fexldr_ptr_libdrm_drmGetHashTable = dlsym_default(fexldr_ptr_libdrm_so, "drmGetHashTable");
  (void*&)fexldr_ptr_libdrm_drmGetEntry = dlsym_default(fexldr_ptr_libdrm_so, "drmGetEntry");
  (void*&)fexldr_ptr_libdrm_drmAvailable = dlsym_default(fexldr_ptr_libdrm_so, "drmAvailable");
  (void*&)fexldr_ptr_libdrm_drmOpen = dlsym_default(fexldr_ptr_libdrm_so, "drmOpen");
  (void*&)fexldr_ptr_libdrm_drmOpenWithType = dlsym_default(fexldr_ptr_libdrm_so, "drmOpenWithType");
  (void*&)fexldr_ptr_libdrm_drmOpenControl = dlsym_default(fexldr_ptr_libdrm_so, "drmOpenControl");
  (void*&)fexldr_ptr_libdrm_drmOpenRender = dlsym_default(fexldr_ptr_libdrm_so, "drmOpenRender");
  (void*&)fexldr_ptr_libdrm_drmClose = dlsym_default(fexldr_ptr_libdrm_so, "drmClose");
  (void*&)fexldr_ptr_libdrm_drmGetVersion = dlsym_default(fexldr_ptr_libdrm_so, "drmGetVersion");
  (void*&)fexldr_ptr_libdrm_drmGetLibVersion = dlsym_default(fexldr_ptr_libdrm_so, "drmGetLibVersion");
  (void*&)fexldr_ptr_libdrm_drmGetCap = dlsym_default(fexldr_ptr_libdrm_so, "drmGetCap");
  (void*&)fexldr_ptr_libdrm_drmFreeVersion = dlsym_default(fexldr_ptr_libdrm_so, "drmFreeVersion");
  (void*&)fexldr_ptr_libdrm_drmGetMagic = dlsym_default(fexldr_ptr_libdrm_so, "drmGetMagic");
  (void*&)fexldr_ptr_libdrm_drmGetBusid = dlsym_default(fexldr_ptr_libdrm_so, "drmGetBusid");
  (void*&)fexldr_ptr_libdrm_drmGetInterruptFromBusID = dlsym_default(fexldr_ptr_libdrm_so, "drmGetInterruptFromBusID");
  (void*&)fexldr_ptr_libdrm_drmGetMap = dlsym_default(fexldr_ptr_libdrm_so, "drmGetMap");
  (void*&)fexldr_ptr_libdrm_drmGetClient = dlsym_default(fexldr_ptr_libdrm_so, "drmGetClient");
  (void*&)fexldr_ptr_libdrm_drmGetStats = dlsym_default(fexldr_ptr_libdrm_so, "drmGetStats");
  (void*&)fexldr_ptr_libdrm_drmSetInterfaceVersion = dlsym_default(fexldr_ptr_libdrm_so, "drmSetInterfaceVersion");
  (void*&)fexldr_ptr_libdrm_drmCommandNone = dlsym_default(fexldr_ptr_libdrm_so, "drmCommandNone");
  (void*&)fexldr_ptr_libdrm_drmCommandRead = dlsym_default(fexldr_ptr_libdrm_so, "drmCommandRead");
  (void*&)fexldr_ptr_libdrm_drmCommandWrite = dlsym_default(fexldr_ptr_libdrm_so, "drmCommandWrite");
  (void*&)fexldr_ptr_libdrm_drmCommandWriteRead = dlsym_default(fexldr_ptr_libdrm_so, "drmCommandWriteRead");
  (void*&)fexldr_ptr_libdrm_drmFreeBusid = dlsym_default(fexldr_ptr_libdrm_so, "drmFreeBusid");
  (void*&)fexldr_ptr_libdrm_drmSetBusid = dlsym_default(fexldr_ptr_libdrm_so, "drmSetBusid");
  (void*&)fexldr_ptr_libdrm_drmAuthMagic = dlsym_default(fexldr_ptr_libdrm_so, "drmAuthMagic");
  (void*&)fexldr_ptr_libdrm_drmAddMap = dlsym_default(fexldr_ptr_libdrm_so, "drmAddMap");
  (void*&)fexldr_ptr_libdrm_drmRmMap = dlsym_default(fexldr_ptr_libdrm_so, "drmRmMap");
  (void*&)fexldr_ptr_libdrm_drmAddContextPrivateMapping = dlsym_default(fexldr_ptr_libdrm_so, "drmAddContextPrivateMapping");
  (void*&)fexldr_ptr_libdrm_drmAddBufs = dlsym_default(fexldr_ptr_libdrm_so, "drmAddBufs");
  (void*&)fexldr_ptr_libdrm_drmMarkBufs = dlsym_default(fexldr_ptr_libdrm_so, "drmMarkBufs");
  (void*&)fexldr_ptr_libdrm_drmCreateContext = dlsym_default(fexldr_ptr_libdrm_so, "drmCreateContext");
  (void*&)fexldr_ptr_libdrm_drmSetContextFlags = dlsym_default(fexldr_ptr_libdrm_so, "drmSetContextFlags");
  (void*&)fexldr_ptr_libdrm_drmGetContextFlags = dlsym_default(fexldr_ptr_libdrm_so, "drmGetContextFlags");
  (void*&)fexldr_ptr_libdrm_drmAddContextTag = dlsym_default(fexldr_ptr_libdrm_so, "drmAddContextTag");
  (void*&)fexldr_ptr_libdrm_drmDelContextTag = dlsym_default(fexldr_ptr_libdrm_so, "drmDelContextTag");
  (void*&)fexldr_ptr_libdrm_drmGetContextTag = dlsym_default(fexldr_ptr_libdrm_so, "drmGetContextTag");
  (void*&)fexldr_ptr_libdrm_drmGetReservedContextList = dlsym_default(fexldr_ptr_libdrm_so, "drmGetReservedContextList");
  (void*&)fexldr_ptr_libdrm_drmFreeReservedContextList = dlsym_default(fexldr_ptr_libdrm_so, "drmFreeReservedContextList");
  (void*&)fexldr_ptr_libdrm_drmSwitchToContext = dlsym_default(fexldr_ptr_libdrm_so, "drmSwitchToContext");
  (void*&)fexldr_ptr_libdrm_drmDestroyContext = dlsym_default(fexldr_ptr_libdrm_so, "drmDestroyContext");
  (void*&)fexldr_ptr_libdrm_drmCreateDrawable = dlsym_default(fexldr_ptr_libdrm_so, "drmCreateDrawable");
  (void*&)fexldr_ptr_libdrm_drmDestroyDrawable = dlsym_default(fexldr_ptr_libdrm_so, "drmDestroyDrawable");
  (void*&)fexldr_ptr_libdrm_drmUpdateDrawableInfo = dlsym_default(fexldr_ptr_libdrm_so, "drmUpdateDrawableInfo");
  (void*&)fexldr_ptr_libdrm_drmCtlInstHandler = dlsym_default(fexldr_ptr_libdrm_so, "drmCtlInstHandler");
  (void*&)fexldr_ptr_libdrm_drmCtlUninstHandler = dlsym_default(fexldr_ptr_libdrm_so, "drmCtlUninstHandler");
  (void*&)fexldr_ptr_libdrm_drmSetClientCap = dlsym_default(fexldr_ptr_libdrm_so, "drmSetClientCap");
  (void*&)fexldr_ptr_libdrm_drmCrtcGetSequence = dlsym_default(fexldr_ptr_libdrm_so, "drmCrtcGetSequence");
  (void*&)fexldr_ptr_libdrm_drmCrtcQueueSequence = dlsym_default(fexldr_ptr_libdrm_so, "drmCrtcQueueSequence");
  (void*&)fexldr_ptr_libdrm_drmMap = dlsym_default(fexldr_ptr_libdrm_so, "drmMap");
  (void*&)fexldr_ptr_libdrm_drmUnmap = dlsym_default(fexldr_ptr_libdrm_so, "drmUnmap");
  (void*&)fexldr_ptr_libdrm_drmGetBufInfo = dlsym_default(fexldr_ptr_libdrm_so, "drmGetBufInfo");
  (void*&)fexldr_ptr_libdrm_drmMapBufs = dlsym_default(fexldr_ptr_libdrm_so, "drmMapBufs");
  (void*&)fexldr_ptr_libdrm_drmUnmapBufs = dlsym_default(fexldr_ptr_libdrm_so, "drmUnmapBufs");
  (void*&)fexldr_ptr_libdrm_drmDMA = dlsym_default(fexldr_ptr_libdrm_so, "drmDMA");
  (void*&)fexldr_ptr_libdrm_drmFreeBufs = dlsym_default(fexldr_ptr_libdrm_so, "drmFreeBufs");
  (void*&)fexldr_ptr_libdrm_drmGetLock = dlsym_default(fexldr_ptr_libdrm_so, "drmGetLock");
  (void*&)fexldr_ptr_libdrm_drmUnlock = dlsym_default(fexldr_ptr_libdrm_so, "drmUnlock");
  (void*&)fexldr_ptr_libdrm_drmFinish = dlsym_default(fexldr_ptr_libdrm_so, "drmFinish");
  (void*&)fexldr_ptr_libdrm_drmGetContextPrivateMapping = dlsym_default(fexldr_ptr_libdrm_so, "drmGetContextPrivateMapping");
  (void*&)fexldr_ptr_libdrm_drmScatterGatherAlloc = dlsym_default(fexldr_ptr_libdrm_so, "drmScatterGatherAlloc");
  (void*&)fexldr_ptr_libdrm_drmScatterGatherFree = dlsym_default(fexldr_ptr_libdrm_so, "drmScatterGatherFree");
  (void*&)fexldr_ptr_libdrm_drmWaitVBlank = dlsym_default(fexldr_ptr_libdrm_so, "drmWaitVBlank");
  (void*&)fexldr_ptr_libdrm_drmSetServerInfo = dlsym_default(fexldr_ptr_libdrm_so, "drmSetServerInfo");
  (void*&)fexldr_ptr_libdrm_drmError = dlsym_default(fexldr_ptr_libdrm_so, "drmError");
  (void*&)fexldr_ptr_libdrm_drmMalloc = dlsym_default(fexldr_ptr_libdrm_so, "drmMalloc");
  (void*&)fexldr_ptr_libdrm_drmFree = dlsym_default(fexldr_ptr_libdrm_so, "drmFree");
  (void*&)fexldr_ptr_libdrm_drmHashCreate = dlsym_default(fexldr_ptr_libdrm_so, "drmHashCreate");
  (void*&)fexldr_ptr_libdrm_drmHashDestroy = dlsym_default(fexldr_ptr_libdrm_so, "drmHashDestroy");
  (void*&)fexldr_ptr_libdrm_drmHashLookup = dlsym_default(fexldr_ptr_libdrm_so, "drmHashLookup");
  (void*&)fexldr_ptr_libdrm_drmHashInsert = dlsym_default(fexldr_ptr_libdrm_so, "drmHashInsert");
  (void*&)fexldr_ptr_libdrm_drmHashDelete = dlsym_default(fexldr_ptr_libdrm_so, "drmHashDelete");
  (void*&)fexldr_ptr_libdrm_drmHashFirst = dlsym_default(fexldr_ptr_libdrm_so, "drmHashFirst");
  (void*&)fexldr_ptr_libdrm_drmHashNext = dlsym_default(fexldr_ptr_libdrm_so, "drmHashNext");
  (void*&)fexldr_ptr_libdrm_drmRandomCreate = dlsym_default(fexldr_ptr_libdrm_so, "drmRandomCreate");
  (void*&)fexldr_ptr_libdrm_drmRandomDestroy = dlsym_default(fexldr_ptr_libdrm_so, "drmRandomDestroy");
  (void*&)fexldr_ptr_libdrm_drmRandom = dlsym_default(fexldr_ptr_libdrm_so, "drmRandom");
  (void*&)fexldr_ptr_libdrm_drmRandomDouble = dlsym_default(fexldr_ptr_libdrm_so, "drmRandomDouble");
  (void*&)fexldr_ptr_libdrm_drmSLCreate = dlsym_default(fexldr_ptr_libdrm_so, "drmSLCreate");
  (void*&)fexldr_ptr_libdrm_drmSLDestroy = dlsym_default(fexldr_ptr_libdrm_so, "drmSLDestroy");
  (void*&)fexldr_ptr_libdrm_drmSLLookup = dlsym_default(fexldr_ptr_libdrm_so, "drmSLLookup");
  (void*&)fexldr_ptr_libdrm_drmSLInsert = dlsym_default(fexldr_ptr_libdrm_so, "drmSLInsert");
  (void*&)fexldr_ptr_libdrm_drmSLDelete = dlsym_default(fexldr_ptr_libdrm_so, "drmSLDelete");
  (void*&)fexldr_ptr_libdrm_drmSLNext = dlsym_default(fexldr_ptr_libdrm_so, "drmSLNext");
  (void*&)fexldr_ptr_libdrm_drmSLFirst = dlsym_default(fexldr_ptr_libdrm_so, "drmSLFirst");
  (void*&)fexldr_ptr_libdrm_drmSLDump = dlsym_default(fexldr_ptr_libdrm_so, "drmSLDump");
  (void*&)fexldr_ptr_libdrm_drmSLLookupNeighbors = dlsym_default(fexldr_ptr_libdrm_so, "drmSLLookupNeighbors");
  (void*&)fexldr_ptr_libdrm_drmOpenOnce = dlsym_default(fexldr_ptr_libdrm_so, "drmOpenOnce");
  (void*&)fexldr_ptr_libdrm_drmOpenOnceWithType = dlsym_default(fexldr_ptr_libdrm_so, "drmOpenOnceWithType");
  (void*&)fexldr_ptr_libdrm_drmCloseOnce = dlsym_default(fexldr_ptr_libdrm_so, "drmCloseOnce");
  (void*&)fexldr_ptr_libdrm_drmSetMaster = dlsym_default(fexldr_ptr_libdrm_so, "drmSetMaster");
  (void*&)fexldr_ptr_libdrm_drmDropMaster = dlsym_default(fexldr_ptr_libdrm_so, "drmDropMaster");
  (void*&)fexldr_ptr_libdrm_drmIsMaster = dlsym_default(fexldr_ptr_libdrm_so, "drmIsMaster");
  (void*&)fexldr_ptr_libdrm_drmHandleEvent = dlsym_default(fexldr_ptr_libdrm_so, "drmHandleEvent");
  (void*&)fexldr_ptr_libdrm_drmGetDeviceNameFromFd = dlsym_default(fexldr_ptr_libdrm_so, "drmGetDeviceNameFromFd");
  (void*&)fexldr_ptr_libdrm_drmGetDeviceNameFromFd2 = dlsym_default(fexldr_ptr_libdrm_so, "drmGetDeviceNameFromFd2");
  (void*&)fexldr_ptr_libdrm_drmGetNodeTypeFromFd = dlsym_default(fexldr_ptr_libdrm_so, "drmGetNodeTypeFromFd");
  (void*&)fexldr_ptr_libdrm_drmPrimeHandleToFD = dlsym_default(fexldr_ptr_libdrm_so, "drmPrimeHandleToFD");
  (void*&)fexldr_ptr_libdrm_drmPrimeFDToHandle = dlsym_default(fexldr_ptr_libdrm_so, "drmPrimeFDToHandle");
  (void*&)fexldr_ptr_libdrm_drmGetPrimaryDeviceNameFromFd = dlsym_default(fexldr_ptr_libdrm_so, "drmGetPrimaryDeviceNameFromFd");
  (void*&)fexldr_ptr_libdrm_drmGetRenderDeviceNameFromFd = dlsym_default(fexldr_ptr_libdrm_so, "drmGetRenderDeviceNameFromFd");
  (void*&)fexldr_ptr_libdrm_drmGetDevice = dlsym_default(fexldr_ptr_libdrm_so, "drmGetDevice");
  (void*&)fexldr_ptr_libdrm_drmFreeDevice = dlsym_default(fexldr_ptr_libdrm_so, "drmFreeDevice");
  (void*&)fexldr_ptr_libdrm_drmGetDevices = dlsym_default(fexldr_ptr_libdrm_so, "drmGetDevices");
  (void*&)fexldr_ptr_libdrm_drmFreeDevices = dlsym_default(fexldr_ptr_libdrm_so, "drmFreeDevices");
  (void*&)fexldr_ptr_libdrm_drmGetDevice2 = dlsym_default(fexldr_ptr_libdrm_so, "drmGetDevice2");
  (void*&)fexldr_ptr_libdrm_drmGetDevices2 = dlsym_default(fexldr_ptr_libdrm_so, "drmGetDevices2");
  (void*&)fexldr_ptr_libdrm_drmDevicesEqual = dlsym_default(fexldr_ptr_libdrm_so, "drmDevicesEqual");
  (void*&)fexldr_ptr_libdrm_drmSyncobjCreate = dlsym_default(fexldr_ptr_libdrm_so, "drmSyncobjCreate");
  (void*&)fexldr_ptr_libdrm_drmSyncobjDestroy = dlsym_default(fexldr_ptr_libdrm_so, "drmSyncobjDestroy");
  (void*&)fexldr_ptr_libdrm_drmSyncobjHandleToFD = dlsym_default(fexldr_ptr_libdrm_so, "drmSyncobjHandleToFD");
  (void*&)fexldr_ptr_libdrm_drmSyncobjFDToHandle = dlsym_default(fexldr_ptr_libdrm_so, "drmSyncobjFDToHandle");
  (void*&)fexldr_ptr_libdrm_drmSyncobjImportSyncFile = dlsym_default(fexldr_ptr_libdrm_so, "drmSyncobjImportSyncFile");
  (void*&)fexldr_ptr_libdrm_drmSyncobjExportSyncFile = dlsym_default(fexldr_ptr_libdrm_so, "drmSyncobjExportSyncFile");
  (void*&)fexldr_ptr_libdrm_drmSyncobjWait = dlsym_default(fexldr_ptr_libdrm_so, "drmSyncobjWait");
  (void*&)fexldr_ptr_libdrm_drmSyncobjReset = dlsym_default(fexldr_ptr_libdrm_so, "drmSyncobjReset");
  (void*&)fexldr_ptr_libdrm_drmSyncobjSignal = dlsym_default(fexldr_ptr_libdrm_so, "drmSyncobjSignal");
  (void*&)fexldr_ptr_libdrm_drmSyncobjTimelineSignal = dlsym_default(fexldr_ptr_libdrm_so, "drmSyncobjTimelineSignal");
  (void*&)fexldr_ptr_libdrm_drmSyncobjTimelineWait = dlsym_default(fexldr_ptr_libdrm_so, "drmSyncobjTimelineWait");
  (void*&)fexldr_ptr_libdrm_drmSyncobjQuery = dlsym_default(fexldr_ptr_libdrm_so, "drmSyncobjQuery");
  (void*&)fexldr_ptr_libdrm_drmSyncobjQuery2 = dlsym_default(fexldr_ptr_libdrm_so, "drmSyncobjQuery2");
  (void*&)fexldr_ptr_libdrm_drmSyncobjTransfer = dlsym_default(fexldr_ptr_libdrm_so, "drmSyncobjTransfer");
  return true;
}
